/*
 *  draw_edges.cpp
 *
 *  Created by Kari Haugsdal
 */

#include <SDL.h>
#include <iostream>
#include "SDL_opengl.h"		// platform independent OpenGL include
#include "draw_edges.h"

//hmm, hack, lag en stor nok liste til at det gar bra med de fleste tilfeller. De fleste edger er under 500 pixel lang, plus du sjekker bare en liten lengde av de igjen av gangen.
//forhapentlig vis ingen edge som er lenger en 10000 piksler! Kan implementeres i bli kvitt GetRidOfSmallEdges()
int XList[10000] = {0}; 
int YList[10000] = {0};

void printarray (int arg[], int length) {
  std::cout << "[" ;
  for (int n=0; n<length; n++){
	std::cout << arg[n] << " ";
  }
  std::cout << "]" ;
  std::cout << "\n";
}

//funker perfekt!
void DrawLine(int xStart, int yStart, int xEnd, int yEnd, float c1, float c2, float c3){

	//glColor3f(1.0f,0.0f,0.0f);							// Set The Color To Red
	glColor3f(c1, c2, c3);									// Set to input
	glBegin(GL_LINES);
		glVertex3f(xStart, -yStart, 0.0f);					// Start
		glVertex3f(xEnd, -yEnd, 0.0f);						// End
	glEnd();

}

bool ShouldIDrawLine(int xStart, int yStart, int xEnd, int yEnd, float c1, float c2, float c3, int counter, bool endCordinate, float limit){

	bool okToContinu = true;
	for (int x = 1; x < counter; x++){
		//printarray(XList, x);
		//printarray(YList, x);
		//sjekk at ikke error er for stor
		int mX = XList[x];
		int mY = YList[x];
		float error = ComputePolygonError(xStart, yStart, mX, mY, xEnd, yEnd, limit);
		//std::cout << "Error: " << error << std::endl;
		if(error > limit){ //if error to big
			okToContinu = false;
		}	
	}
	if (!okToContinu || endCordinate){
		DrawLine(xStart, yStart, xEnd, yEnd, c1, c2, c3);
		return true;
	}
	return false;
}


void DrawEdge(SDL_Surface *copy, int StartX, int StartY, int errorLimit, float c1, float c2, float c3) {

	pixel * pixels = (pixel*) copy->pixels;
	
	int counter = 0;
	XList[counter] = StartX;
	YList[counter] = StartY;
	
	int StartType = pixels[StartX + StartY * (copy->w)].r;
	int StartB = pixels[StartX + StartY * (copy->w)].b;
	int StartG = pixels[StartX + StartY * (copy->w)].g;
	//the draw kordinates
	int dsX, dsY, deX, deY;
	//if(StartB > 0 && StartG > 0){
		//std::cout << "Pixel x: " << StartX << " y: " << StartY << " B Value: " << StartB << " G Value: " << StartG << " Type: " << StartType  << std::endl;
		//I tilegg til print, draw. Trenger start og stop kordinat, derfor ma forste pixel lagres for jeg kan draw
		dsX = StartX;
		dsY = StartY;
	//}
	
	int StartAndEndX, StartAndEndY, StartAndEndR, StartAndEndB, StartAndEndG;
	if (StartType == 4){
		//save start pixel
		StartAndEndX = StartX;
		StartAndEndY = StartY;
		StartAndEndB = StartB;
		StartAndEndG = StartG;
		StartAndEndR = StartType;
	}

	int centerX = StartX;
	int centerY = StartY;
	int eTempCenterX, eTempCenterY, mTempCenterX, mTempCenterY, gTempCenterX, gTempCenterY;
	
	bool notFinished = true;
	while (notFinished) {
		notFinished = false;
		
		//for print
		//int lastPixelType = pixels[centerX + centerY * (copy->w)].r;
		//int lastPixelB = pixels[centerX + centerY * (copy->w)].b;
		//int lastPixelG = pixels[centerX + centerY * (copy->w)].g;
				
		//delete old pixel along the way
		pixels[centerX + centerY * (copy->w)].r = 0;
		pixels[centerX + centerY * (copy->w)].b = 0;
		pixels[centerX + centerY * (copy->w)].g = 0;
		
		
		//std::cout << "Print all the neighbours: " << std::endl;
		bool mNaboFunnet = false; 
		bool eNaboFunnet = false;
		bool gNaboFunnet = false; 
		//Looping through the neighbours of the current pixel
		for (int i = -1; i < 2; i++) {
			for (int j = -1; j < 2; j++) {
			
				//int NType = pixels[(centerX + i) + (centerY + j) * (copy->w)].r;
				//int NPixelB = pixels[(centerX + i) + (centerY + j) * (copy->w)].b;
				//int NPixelG = pixels[(centerX + i) + (centerY + j) * (copy->w)].g;
				//int Nx = centerX + i;
				//int Ny = centerY + j;
				//std::cout << "Pixel x: " << Nx << " Pixel y: " << Ny << " B Value: " << NPixelB << " G Value: " << NPixelG << " Type: " << NType  << std::endl;
				
				int b = pixels[(centerX + i) + (centerY + j) * (copy->w)].b;
				int g = pixels[(centerX + i) + (centerY + j) * (copy->w)].g;
				int r = pixels[(centerX + i) + (centerY + j) * (copy->w)].r;
				
				//funni neste pixel
				if( b == StartB && g == StartG && r == 2){
				
					mNaboFunnet = true;
					//put as new center pixel
					mTempCenterX = centerX + i;
					mTempCenterY = centerY + j;
					notFinished = true;
					
				} 
				if( b == StartB && g == StartG && r == 3){
				
					eNaboFunnet = true;
					//put as new center pixel
					eTempCenterX = centerX + i;
					eTempCenterY = centerY + j;
					//notFinished = true;
					
				}
				if( b == StartB && g == StartG && r >= 6){
					//found gap pixel
					gNaboFunnet = true;
					//put as new center pixel
					gTempCenterX = centerX + i;
					gTempCenterY = centerY + j;
					notFinished = true;
				}
									
			}
		} //looping neighbors of current pixel finished
		
		//now it is time to use naboene vi fant
		if(mNaboFunnet){
			centerX = mTempCenterX;
			centerY = mTempCenterY;
			//utprint
			//int nextPixelType = pixels[(centerX) + (centerY) * (copy->w)].r;
			//int nextPixelB = pixels[(centerX) + (centerY) * (copy->w)].b;
			//int nextPixelG = pixels[(centerX) + (centerY) * (copy->w)].g;
			//std::cout << "M Pixel x: " << centerX << " y: " << centerY << " B Value: " << nextPixelB << " G Value: " << nextPixelG << " Type: " << nextPixelType  << std::endl;
			//draw
			deX = mTempCenterX;
			deY = mTempCenterY;
			counter++;
			XList[counter] = deX;
			YList[counter] = deY;
			if(ShouldIDrawLine(dsX, dsY, deX, deY, c1, c2, c3, counter, false, errorLimit)){
				//if yes sett dsX = deX
				dsX = deX;
				dsY = deY;
				counter = 0;
			}
			
		} else if(eNaboFunnet){
			centerX = eTempCenterX;
			centerY = eTempCenterY;
			//int nextPixelType = pixels[(centerX) + (centerY) * (copy->w)].r;
			//int nextPixelB = pixels[(centerX) + (centerY) * (copy->w)].b;
			//int nextPixelG = pixels[(centerX) + (centerY) * (copy->w)].g;
			//std::cout << "E Pixel x: " << centerX << " y: " << centerY << " B Value: " << nextPixelB << " G Value: " << nextPixelG << " Type: " << nextPixelType  << std::endl;
			//draw
			deX = eTempCenterX;
			deY = eTempCenterY;
			counter++;
			XList[counter] = deX;
			YList[counter] = deY;
			if(ShouldIDrawLine(dsX, dsY, deX, deY, c1, c2, c3, counter, true, errorLimit)){
				//if yes sett dsX = deX
				dsX = deX;
				dsY = deY;
				counter = 0;
			}
			
		} else if(gNaboFunnet){
			//ikke bare utprint her!
			int nextPixelType = pixels[(gTempCenterX) + (gTempCenterY) * (copy->w)].r;
			int nextPixelB = pixels[(gTempCenterX) + (gTempCenterY) * (copy->w)].b;
			int nextPixelG = pixels[(gTempCenterX) + (gTempCenterY) * (copy->w)].g;
			//std::cout << "Gap Pixel x: " << centerX << " y: " << centerY << " B Value: " << nextPixelB << " G Value: " << nextPixelG << " Type: " << nextPixelType  << std::endl;
			//draw
			deX = gTempCenterX;
			deY = gTempCenterY;
			counter++;
			XList[counter] = deX;
			YList[counter] = deY;
			if(ShouldIDrawLine(dsX, dsY, deX, deY, c1, c2, c3, counter, false, errorLimit)){
				//if yes sett dsX = deX
				dsX = deX;
				dsY = deY;
				counter = 0;
			}
			
			pixels[gTempCenterX + gTempCenterY * (copy->w)].r = 0;
			pixels[gTempCenterX + gTempCenterY * (copy->w)].b = 0;
			pixels[gTempCenterX + gTempCenterY * (copy->w)].g = 0;
			//search whole picture after matching G and set as center
			for (int r = 1; r < copy->w-1; r++) {
				for (int s = 1; s < copy->h-1; s++) {
					
					int gType = pixels[r + s * (copy->w)].r;
					int gB = pixels[r + s * (copy->w)].b;
					int gG = pixels[r + s * (copy->w)].g;
					
					if( gType == nextPixelType && gB == nextPixelB && gG == nextPixelG){
					
						//std::cout << "G nabo sin matchende G funnet!" << std::endl;
						centerX = r;
						centerY = s;
						//int nextPixelType = pixels[(centerX) + (centerY) * (copy->w)].r;
						//int nextPixelB = pixels[(centerX) + (centerY) * (copy->w)].b;
						//int nextPixelG = pixels[(centerX) + (centerY) * (copy->w)].g;
						//std::cout << "Gap Pixel x: " << centerX << " y: " << centerY << " B Value: " << nextPixelB << " G Value: " << nextPixelG << " Type: " << nextPixelType  << std::endl;
						//draw
						deX = centerX;
						deY = centerY;
						counter++;
						XList[counter] = deX;
						YList[counter] = deY;
						if(ShouldIDrawLine(dsX, dsY, deX, deY, c1, c2, c3, counter, false, errorLimit)){
							//if yes sett dsX = deX
							dsX = deX;
							dsY = deY;
							counter = 0;
						}
					}
				
				}
			}
			
		}
		
		//nabo SaE funnet
		if(!mNaboFunnet && !gNaboFunnet && StartType == 4){
			centerX = StartAndEndX;
			centerY = StartAndEndY;
			//int nextPixelType = StartAndEndR;
			//int nextPixelB = StartAndEndB;
			//int nextPixelG = StartAndEndG;
			//std::cout << "SaE Pixel x: " << centerX << " y: " << centerY << " B Value: " << nextPixelB << " G Value: " << nextPixelG << " Type: " << nextPixelType  << std::endl;
			//draw
			deX = centerX;
			deY = centerY;
			counter++;
			XList[counter] = deX;
			YList[counter] = deY;
			if(ShouldIDrawLine(dsX, dsY, deX, deY, c1, c2, c3, counter, true, errorLimit)){
				//if yes sett dsX = deX
				dsX = deX;
				dsY = deY;
				counter = 0;
			}
		}


	}//while is finished

	//std::cout << "End of Edge! " << std::endl;
	//std::cout << " " << std::endl;
}


bool ShouldIDrawLineQuestion(int xStart, int yStart, int xEnd, int yEnd, int xOld, int yOld, int counter, bool endCordinate, float limit){

	bool okToContinu = true;
	for (int x = 1; x < counter; x++){
		//sjekk at ikke error er for stor
		int mX = XList[x];
		int mY = YList[x];
		float error = ComputePolygonError(xStart, yStart, mX, mY, xEnd, yEnd, limit);
		if(error > limit){ //if error to big
			okToContinu = false;
		}	
	}
	if (!okToContinu || endCordinate){
		//DrawLine(xStart, yStart, xEnd, yEnd, 1, 0, 0);
		return true;
	}
	return false;
}

bool CornerFound(int xStart, int yStart, int xEnd, int yEnd, int xOld, int yOld, int counter, bool endCordinate, float limit, int cornerLimit){

	bool okToContinu = true;
	bool hjorneFunnet = false;
	for (int x = 1; x < counter; x++){
		//sjekk at ikke error er for stor
		int mX = XList[x];
		int mY = YList[x];
		float error = ComputePolygonError(xStart, yStart, mX, mY, xEnd, yEnd, limit);
		if(error > limit){ //if error to big
			okToContinu = false;
		}	
	}
	if (!okToContinu || endCordinate){
	
		//compute angel between old line and new line if we have two lines to compare (!okToContinu)
		float angel = 180;
		if(xOld != -1 && yOld != -1){
			angel = ComputeAngel(xStart, yStart, xEnd, yEnd, xOld, yOld);
			//std::cout << "Sx: " << xStart << " Sy: " << yStart << " Ex: " << xEnd << " Ey: " << yEnd << " Ox: " << xOld << " Oy: " << yOld << std::endl;
		}
		if(angel > cornerLimit){
			//std::cout << "is a line" << std::endl;
		} else if(angel <= cornerLimit){
			//std::cout << "is a corner" << std::endl;
			//da er angel et hjorne! Tell disse!
			hjorneFunnet = true;
		}
	}
	
	//if(endCordinate){
		//gjorne ikke funnet, bare tegn
		//DrawLine(xStart, yStart, xEnd, yEnd, 0, 1, 0);
		//hjorneFunnet = false;
	//}
	
	return hjorneFunnet;	
}

bool StrictCornerFound(int xStart, int yStart, int xEnd, int yEnd, int xOld, int yOld, int counter, bool endCordinate, float limit, int cornerLimit){

	int theLimit = 180 - cornerLimit;

	bool okToContinu = true;
	bool hjorneFunnet = false;
	
	for (int x = 1; x < counter; x++){
		//sjekk at ikke error er for stor
		int mX = XList[x];
		int mY = YList[x];
		float error = ComputePolygonError(xStart, yStart, mX, mY, xEnd, yEnd, limit);
		if(error > limit){ //if error to big
			okToContinu = false;
		}	
	}

	if (!okToContinu){
	
		//compute angel between old line and new line if we have two lines to compare
		if(xOld != -1 && yOld != -1){
			float angel = ComputeAngel(xStart, yStart, xEnd, yEnd, xOld, yOld);
			//std::cout << "Sx: " << xStart << " Sy: " << yStart << " Ex: " << xEnd << " Ey: " << yEnd << " Ox: " << xOld << " Oy: " << yOld << std::endl;
			//std::cout << "Line angel is: " << angel << std::endl;
			//often nan (not a number), this equals straight line and is an acceptable degree
			if(angel > theLimit){
				//akseptabel for linje
			} else if(angel <= theLimit){
				//da er angel et hjorne! Tell disse!
				//std::cout << "For stor vinkel, strenkt Hjorne funnet!: " << angel << std::endl;
				hjorneFunnet = true;
				
			}
		}
		
		//DrawLine(xStart, yStart, xEnd, yEnd, c1, c2, c3);
		return hjorneFunnet;
		
	} else if (endCordinate) {
	
		//compute angel between old line and new line if we have two lines to compare
		if(xOld != -1 && yOld != -1){
			float angel = ComputeAngel(xStart, yStart, xEnd, yEnd, xOld, yOld);
			//std::cout << "Sx: " << xStart << " Sy: " << yStart << " Ex: " << xEnd << " Ey: " << yEnd << " Ox: " << xOld << " Oy: " << yOld << std::endl;
			//std::cout << "Line angel is: " << angel << std::endl;
			//often nan (not a number), this equals straight line and is an acceptable degree
			if(angel > theLimit){
				//akseptabel for linje
			} else if(angel <= theLimit){
				//da er angel et hjorne! Tell disse!
				//std::cout << "For stor vinkel, strengt Hjorne funnet!: " << angel << std::endl;
				hjorneFunnet = true;
			}
		}

		//DrawLine(xStart, yStart, xEnd, yEnd, c1, c2, c3);
		return hjorneFunnet;
	}
	
	return hjorneFunnet;
	
}


bool ZigZag(int xStart, int yStart, int xEnd, int yEnd, int xOld, int yOld, int xXOld, int yXOld){

	bool zigZagFound = false;
		
	float angelStart = ComputeAngel(xStart, yStart, xOld, yOld, xEnd, yEnd); // Start corner angel
	float angelEnd = ComputeAngel(xEnd, yEnd, xXOld, yXOld, xStart, yStart); // End corner angel
	float angelXOld = ComputeAngel(xXOld, yXOld, xOld, yOld, xEnd, yEnd); // XOld corner angel
	float angelOld = ComputeAngel(xOld, yOld, xStart, yStart, xXOld, yXOld); // Old corner angel
			
	float angelSum = angelStart + angelEnd + angelXOld + angelOld;
			
	if (angelSum < 360){
		//then we have zigzag
		//std::cout << "ZigZag funnet!" << std::endl;
		zigZagFound = true;
	}
		
	return zigZagFound;
	
}


int ShapeRecognition(SDL_Surface *copy, int StartX, int StartY, int errorLimit, float c1, float c2, float c3, int cornerLimit, int strictCornerLimit, int smalestDegreeTriangel, int squareSideLimit) {

	pixel * pixels = (pixel*) copy->pixels;
	
	int infoCounter = 0;
	int cornerCounter = 0;
	int strictCornerCounter = 0;
	
	int counter = 0;
	XList[counter] = StartX;
	YList[counter] = StartY;
	
	int StartType = pixels[StartX + StartY * (copy->w)].r;
	int StartB = pixels[StartX + StartY * (copy->w)].b;
	int StartG = pixels[StartX + StartY * (copy->w)].g;
	
	//the draw kordinates
	int dsX, dsY, deX, deY, oldX, oldY;
	//std::cout << "Pixel x: " << StartX << " y: " << StartY << " B Value: " << StartB << " G Value: " << StartG << " Type: " << StartType  << std::endl;
	//I tilegg til print, draw. Trenger start og stop kordinat, derfor ma forste pixel lagres for jeg kan draw
	dsX = StartX;
	dsY = StartY;
	oldX = -1;
	oldY = -1;
	
	int h1x, h1y, h2x, h2y, h3x, h3y, h4x, h4y;
	
	int StartAndEndX, StartAndEndY, StartAndEndR, StartAndEndB, StartAndEndG;
	if (StartType == 4){
		//save start pixel
		StartAndEndX = StartX;
		StartAndEndY = StartY;
		StartAndEndB = StartB;
		StartAndEndG = StartG;
		StartAndEndR = StartType;
	}

	int centerX = StartX;
	int centerY = StartY;
	int eTempCenterX, eTempCenterY, mTempCenterX, mTempCenterY, gTempCenterX, gTempCenterY;
	bool firstSaEPixelNotFoundYet = true;
	int firstSaEPixelXFound, firstSaEPixelYFound;
	
	bool notFinished = true;
	while (notFinished) {
		notFinished = false;
		
		//for print
		//int lastPixelType = pixels[centerX + centerY * (copy->w)].r;
		//int lastPixelB = pixels[centerX + centerY * (copy->w)].b;
		//int lastPixelG = pixels[centerX + centerY * (copy->w)].g;
				
		//delete old pixel along the way
		pixels[centerX + centerY * (copy->w)].r = 0;
		pixels[centerX + centerY * (copy->w)].b = 0;
		pixels[centerX + centerY * (copy->w)].g = 0;
		
		
		//std::cout << "Print all the neighbours: " << std::endl;
		bool mNaboFunnet = false; 
		bool eNaboFunnet = false;
		bool gNaboFunnet = false; 
		//Looping through the neighbours of the current pixel
		for (int i = -1; i < 2; i++) {
			for (int j = -1; j < 2; j++) {
			
				//int NType = pixels[(centerX + i) + (centerY + j) * (copy->w)].r;
				//int NPixelB = pixels[(centerX + i) + (centerY + j) * (copy->w)].b;
				//int NPixelG = pixels[(centerX + i) + (centerY + j) * (copy->w)].g;
				//int Nx = centerX + i;
				//int Ny = centerY + j;
				//std::cout << "Pixel x: " << Nx << " Pixel y: " << Ny << " B Value: " << NPixelB << " G Value: " << NPixelG << " Type: " << NType  << std::endl;
				
				int b = pixels[(centerX + i) + (centerY + j) * (copy->w)].b;
				int g = pixels[(centerX + i) + (centerY + j) * (copy->w)].g;
				int r = pixels[(centerX + i) + (centerY + j) * (copy->w)].r;
				
				//funni neste pixel
				if( b == StartB && g == StartG && r == 2){
				
					mNaboFunnet = true;
					//put as new center pixel
					mTempCenterX = centerX + i;
					mTempCenterY = centerY + j;
					notFinished = true;
					
					//if SaE, ta vare pa forste pixel enquntered!
					if(StartType == 4 && firstSaEPixelNotFoundYet){
						firstSaEPixelNotFoundYet = false;
						firstSaEPixelXFound = centerX + i;
						firstSaEPixelYFound = centerY + j;
					}
					
				} 
				if( b == StartB && g == StartG && r == 3){
				
					eNaboFunnet = true;
					//put as new center pixel
					eTempCenterX = centerX + i;
					eTempCenterY = centerY + j;
					//notFinished = true;
					
				}
				if( b == StartB && g == StartG && r >= 6){
					//found gap pixel
					gNaboFunnet = true;
					//put as new center pixel
					gTempCenterX = centerX + i;
					gTempCenterY = centerY + j;
					notFinished = true;
				}
									
			}
		} //looping neighbors of current pixel finished
		
		//now it is time to use naboene vi fant
		if(mNaboFunnet){
			centerX = mTempCenterX;
			centerY = mTempCenterY;
			//utprint
			//int nextPixelType = pixels[(centerX) + (centerY) * (copy->w)].r;
			//int nextPixelB = pixels[(centerX) + (centerY) * (copy->w)].b;
			//int nextPixelG = pixels[(centerX) + (centerY) * (copy->w)].g;
			//std::cout << "M Pixel x: " << centerX << " y: " << centerY << " B Value: " << nextPixelB << " G Value: " << nextPixelG << " Type: " << nextPixelType  << std::endl;
			//draw
			deX = mTempCenterX;
			deY = mTempCenterY;
			counter++;
			XList[counter] = deX;
			YList[counter] = deY;
			if(ShouldIDrawLineQuestion(dsX, dsY, deX, deY, oldX, oldY, counter, false, errorLimit)){
				bool cornerFound = CornerFound(dsX, dsY, deX, deY, oldX, oldY, counter, false, errorLimit, cornerLimit);
				bool strictCornerFound = StrictCornerFound(dsX, dsY, deX, deY, oldX, oldY, counter, false, errorLimit, strictCornerLimit);
				if(strictCornerFound){
					strictCornerCounter++;
				}
				if (cornerFound){
					cornerCounter++;
					if( cornerCounter == 1){
						h1x = dsX;
						h1y = dsY;
					}
					if( cornerCounter == 2){
						h2x = dsX;
						h2y = dsY;
					}
					if( cornerCounter == 3){
						h3x = dsX;
						h3y = dsY;
					}
					if( cornerCounter == 4){
						h4x = dsX;
						h4y = dsY;
					}	
				}
				oldX = dsX;
				oldY = dsY;
				dsX = deX;
				dsY = deY;
				counter = 0;
				infoCounter++;
			}
			
		} else if(eNaboFunnet){
			centerX = eTempCenterX;
			centerY = eTempCenterY;
			//int nextPixelType = pixels[(centerX) + (centerY) * (copy->w)].r;
			//int nextPixelB = pixels[(centerX) + (centerY) * (copy->w)].b;
			//int nextPixelG = pixels[(centerX) + (centerY) * (copy->w)].g;
			//std::cout << "E Pixel x: " << centerX << " y: " << centerY << " B Value: " << nextPixelB << " G Value: " << nextPixelG << " Type: " << nextPixelType  << std::endl;
			//draw
			deX = eTempCenterX;
			deY = eTempCenterY;
			counter++;
			XList[counter] = deX;
			YList[counter] = deY;
			if(ShouldIDrawLineQuestion(dsX, dsY, deX, deY, oldX, oldY, counter, true, errorLimit)){
				bool cornerFound = CornerFound(dsX, dsY, deX, deY, oldX, oldY, counter, true, errorLimit, cornerLimit);
				bool strictCornerFound = StrictCornerFound(dsX, dsY, deX, deY, oldX, oldY, counter, false, errorLimit, strictCornerLimit);
				if(strictCornerFound){
					strictCornerCounter++;
				}
				if (cornerFound){
					cornerCounter++;
					if( cornerCounter == 1){
						h1x = dsX;
						h1y = dsY;
					}
					if( cornerCounter == 2){
						h2x = dsX;
						h2y = dsY;
					}
					if( cornerCounter == 3){
						h3x = dsX;
						h3y = dsY;
					}
					if( cornerCounter == 4){
						h4x = dsX;
						h4y = dsY;
					}
				}
				oldX = dsX;
				oldY = dsY;
				dsX = deX;
				dsY = deY;
				counter = 0;
				infoCounter++;
			}
			
		} else if(gNaboFunnet){
			//ikke bare utprint her!
			int nextPixelType = pixels[(gTempCenterX) + (gTempCenterY) * (copy->w)].r;
			int nextPixelB = pixels[(gTempCenterX) + (gTempCenterY) * (copy->w)].b;
			int nextPixelG = pixels[(gTempCenterX) + (gTempCenterY) * (copy->w)].g;
			//std::cout << "Gap Pixel x: " << centerX << " y: " << centerY << " B Value: " << nextPixelB << " G Value: " << nextPixelG << " Type: " << nextPixelType  << std::endl;
			//draw
			deX = gTempCenterX;
			deY = gTempCenterY;
			counter++;
			XList[counter] = deX;
			YList[counter] = deY;
			if(ShouldIDrawLineQuestion(dsX, dsY, deX, deY, oldX, oldY, counter, false, errorLimit)){
				bool cornerFound = CornerFound(dsX, dsY, deX, deY, oldX, oldY, counter, false, errorLimit, cornerLimit);
				bool strictCornerFound = StrictCornerFound(dsX, dsY, deX, deY, oldX, oldY, counter, false, errorLimit, strictCornerLimit);
				if(strictCornerFound){
					strictCornerCounter++;
				}
				if (cornerFound){
					cornerCounter++;
					if( cornerCounter == 1){
						h1x = dsX;
						h1y = dsY;
					}
					if( cornerCounter == 2){
						h2x = dsX;
						h2y = dsY;
					}
					if( cornerCounter == 3){
						h3x = dsX;
						h3y = dsY;
					}
					if( cornerCounter == 4){
						h4x = dsX;
						h4y = dsY;
					}	
				}
				oldX = dsX;
				oldY = dsY;
				dsX = deX;
				dsY = deY;
				counter = 0;
				infoCounter++;
			}
			
			pixels[gTempCenterX + gTempCenterY * (copy->w)].r = 0;
			pixels[gTempCenterX + gTempCenterY * (copy->w)].b = 0;
			pixels[gTempCenterX + gTempCenterY * (copy->w)].g = 0;
			//search whole picture after matching G and set as center
			for (int r = 1; r < copy->w-1; r++) {
				for (int s = 1; s < copy->h-1; s++) {
					
					int gType = pixels[r + s * (copy->w)].r;
					int gB = pixels[r + s * (copy->w)].b;
					int gG = pixels[r + s * (copy->w)].g;
					
					if( gType == nextPixelType && gB == nextPixelB && gG == nextPixelG){
					
						//std::cout << "G nabo sin matchende G funnet!" << std::endl;
						centerX = r;
						centerY = s;
						//int nextPixelType = pixels[(centerX) + (centerY) * (copy->w)].r;
						//int nextPixelB = pixels[(centerX) + (centerY) * (copy->w)].b;
						//int nextPixelG = pixels[(centerX) + (centerY) * (copy->w)].g;
						//std::cout << "Gap Pixel x: " << centerX << " y: " << centerY << " B Value: " << nextPixelB << " G Value: " << nextPixelG << " Type: " << nextPixelType  << std::endl;
						//draw
						deX = centerX;
						deY = centerY;
						counter++;
						XList[counter] = deX;
						YList[counter] = deY;
						if(ShouldIDrawLineQuestion(dsX, dsY, deX, deY, oldX, oldY, counter, false, errorLimit)){
							bool cornerFound = CornerFound(dsX, dsY, deX, deY, oldX, oldY, counter, false, errorLimit, cornerLimit);
							bool strictCornerFound = StrictCornerFound(dsX, dsY, deX, deY, oldX, oldY, counter, false, errorLimit, strictCornerLimit);
							if(strictCornerFound){
								strictCornerCounter++;
							}
							if (cornerFound){
								cornerCounter++;
								if( cornerCounter == 1){
									h1x = dsX;
									h1y = dsY;
								}
								if( cornerCounter == 2){
									h2x = dsX;
									h2y = dsY;
								}
								if( cornerCounter == 3){
									h3x = dsX;
									h3y = dsY;
								}
								if( cornerCounter == 4){
									h4x = dsX;
									h4y = dsY;
								}
							}
							oldX = dsX;
							oldY = dsY;
							dsX = deX;
							dsY = deY;
							counter = 0;
							infoCounter++;
						}
					}
				
				}
			}
			
		}
		
		//nabo SaE funnet
		if(!mNaboFunnet && !gNaboFunnet && StartType == 4){
			centerX = StartAndEndX;
			centerY = StartAndEndY;
			//int nextPixelType = StartAndEndR;
			//int nextPixelB = StartAndEndB;
			//int nextPixelG = StartAndEndG;
			//std::cout << "SaE Pixel x: " << centerX << " y: " << centerY << " B Value: " << nextPixelB << " G Value: " << nextPixelG << " Type: " << nextPixelType  << std::endl;
			//draw
			deX = centerX;
			deY = centerY;
			counter++;
			XList[counter] = deX;
			YList[counter] = deY;
			if(ShouldIDrawLineQuestion(dsX, dsY, deX, deY, oldX, oldY, counter, true, errorLimit)){ //will altid bli ja siden det er en end pixel vi vurderer
				bool cornerFound = CornerFound(dsX, dsY, deX, deY, oldX, oldY, counter, true, errorLimit, cornerLimit);
				bool strictCornerFound = StrictCornerFound(dsX, dsY, deX, deY, oldX, oldY, counter, true, errorLimit, strictCornerLimit);
				if(strictCornerFound){
					strictCornerCounter++;
				}
				if (cornerFound){
					cornerCounter++;
					if( cornerCounter == 1){
						h1x = dsX;
						h1y = dsY;
					}
					if( cornerCounter == 2){
						h2x = dsX;
						h2y = dsY;
					}
					if( cornerCounter == 3){
						h3x = dsX;
						h3y = dsY;
					}
					if( cornerCounter == 4){
						h4x = dsX;
						h4y = dsY;
					}	
				}
				oldX = dsX;
				oldY = dsY;
				dsX = deX;
				dsY = deY;
				counter = 0;
				infoCounter++;
			}
			
			//ekstra sjekk etter corner siden det er en SaE!
			//compute angel between old line and new line if we have two lines to compare
			//PS SaE sa trenger ikke strictCornerCounter! Men trenger Corner Founnd?
			if(!firstSaEPixelNotFoundYet){
				float angel = ComputeAngel(dsX, dsY, firstSaEPixelXFound , firstSaEPixelYFound, oldX, oldY);
				//often nan (not a number), this equals straight line and is an acceptable degree
				if(angel > cornerLimit){
					//akseptabel for linje
				} else if(angel <= cornerLimit){
					//da er angel et hjorne! Tell disse!
					//std::cout << "Hjorne funnet!: " << angel << std::endl;
					cornerCounter++;
					if( cornerCounter == 1){
						h1x = dsX;
						h1y = dsY;
					}
					if( cornerCounter == 2){
						h2x = dsX;
						h2y = dsY;
					}
					if( cornerCounter == 3){
						h3x = dsX;
						h3y = dsY;
					}
					if( cornerCounter == 4){
						h4x = dsX;
						h4y = dsY;
					}
				}
			}
			
		} //sae nabo finished

	}//while is finished
	
	//SJEKK OVER USING COURNER COUNTER
	//std::cout << "Corner Counter: " << cornerCounter << std::endl;
	
	//sjekk gjort ved 4 hjorner funnet (firkant)
	if(cornerCounter == 4){
		//sjekk for zigzag, ikke lukket edge og for korte sider
		//std::cout << "Firkant " << std::endl;
		//std::cout << "the cordinates - 1x: "<< h1x << " 1y: " << h1y << " 2x: " << h2x << " 2y: " << h2y << " 3x: " << h3x << " 3y: " << h3y << " 4x: " << h4x << " 4y: " << h4y << std::endl;

		bool zigZagFound = ZigZag(h3x, h3y, h4x, h4y, h2x, h2y, h1x, h1y);
		
		float side1 = ComputeTriangelSide(h1x, h1y, h2x, h2y);
		float side2 = ComputeTriangelSide(h2x, h2y, h3x, h3y);
		float side3 = ComputeTriangelSide(h3x, h3y, h4x, h4y);
		float side4 = ComputeTriangelSide(h4x, h4y, h1x, h1y);
		if (zigZagFound || StartType != 4 || (side1 < squareSideLimit) || (side2 < squareSideLimit) || (side3 < squareSideLimit) || (side4 < squareSideLimit)){
			//zigzag in the squere found, thus it is not a square!
			//or it is not closed, and s not a square
			//ps, if start type is 4 sa har vi en blobb (5) men ikke en firkant
			
			if(StartType == 4){
				//std::cout << "ZigZag, eller sidene for korte funnet! - Egentlig en blobb" << std::endl;
				return 5;
			}
			//std::cout << "ZigZag, ikke SaE eller sidene for korte!" << std::endl;
			return 6;
		} 
		
		return 4;
	}
	
	//sjekk gjort ved 3 hjorner funnet (trekant)
	if(cornerCounter == 3){
		//sjekk for veldig liten vinkel, ikke lukket edge
		//std::cout << "Trekant " << std::endl;
		//std::cout << "the cordinates - 1x: "<< h1x << " 1y: " << h1y << " 2x: " << h2x << " 2y: " << h2y << " 3x: " << h3x << " 3y: " << h3y << std::endl;
		
		float angel1 = ComputeAngel(h1x, h1y, h2x, h2y, h3x, h3y);
		float angel2 = ComputeAngel(h2x, h2y, h3x, h3y, h1x, h1y);
		float angel3 = ComputeAngel(h3x, h3y, h1x, h1y, h2x, h2y);
		
		if((angel1 < smalestDegreeTriangel || angel2 < smalestDegreeTriangel ||  angel3 < smalestDegreeTriangel) || StartType != 4){
			//triangel degree is to small to be an distinct triangel!
			//or it is not closed, and s not a square
			
			//ps, if start type is 4 sa har vi en blobb (5) men ikke en firkant
			if(StartType == 4){
				//std::cout << "En vinkel er for liten" << std::endl;
				return 5;
			}
			//std::cout << "Ikke SaE" << std::endl;
			return 6;
		}
		else{
			return 3;
		}
	}
	
	//Etter a ha sjekka firkanter og trekanter sa er alle edger med startType == 4 en blobb
	if(StartType == 4){
		//std::cout << "Blobb because of start type " << std::endl;
		return 5;
	}
	
	if(cornerCounter == 0){
		//mulighet for rett linje, sjekk!
		if (strictCornerCounter == 0){ //annet tall?
			//std::cout << "Linje!" << std::endl;
			//no strict corners found
			return 0;
		}
		//std::cout << "Semi rett linje!" << std::endl;
		return 1;
	}
	
	if(cornerCounter == 5 && StartType != 4){
		//std::cout << "Verken Blobb eller noe annet" << std::endl;
		return 6;
	}

	
	//std::cout << "End of Edge! " << std::endl;
	//std::cout << " " << std::endl;
	
	return cornerCounter;
}


//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------


bool ShouldIDrawLinePoly(int xStart, int yStart, int xEnd, int yEnd, float c1, float c2, float c3, int counter, bool endCordinate, float limit){

	bool okToContinu = true;
	for (int x = 1; x < counter; x++){
		//printarray(XList, x);
		//printarray(YList, x);
		//sjekk at ikke error er for stor
		int mX = XList[x];
		int mY = YList[x];
		float error = ComputePolygonError(xStart, yStart, mX, mY, xEnd, yEnd, limit);
		if(error > limit){ //if error to big
			okToContinu = false;
		}	
	}

	if (!okToContinu){
		
		//draw to last ok line, counter - 1
		//int mX = XList[counter-1];
		//int mY = YList[counter-1];
		//DrawLine(xStart, yStart, mX, mY, c1, c2, c3);
		DrawLine(xStart, yStart, xEnd, yEnd, c1, c2, c3);
		return true;
		
	} else if (endCordinate) {
		DrawLine(xStart, yStart, xEnd, yEnd, c1, c2, c3);
		return true;
	}
	
	return false;
	
}

void DrawInputEdgePoly(SDL_Surface *copy, int StartX, int StartY, int errorLimit) {

	pixel * pixels = (pixel*) copy->pixels;
	
	float c1 = (float) rand()/RAND_MAX;
	float c2 = (float) rand()/RAND_MAX;
	float c3 = (float) rand()/RAND_MAX;
	
	int counter = 0;
	XList[counter] = StartX;
	YList[counter] = StartY;
	
	int StartType = pixels[StartX + StartY * (copy->w)].r;
	int StartB = pixels[StartX + StartY * (copy->w)].b;
	int StartG = pixels[StartX + StartY * (copy->w)].g;
	//the draw kordinates
	int dsX, dsY, deX, deY;
	//if(StartB > 0 && StartG > 0){
		//std::cout << "Pixel x: " << StartX << " y: " << StartY << " B Value: " << StartB << " G Value: " << StartG << " Type: " << StartType  << std::endl;
		//I tilegg til print, draw. Trenger start og stop kordinat, derfor ma forste pixel lagres for jeg kan draw
		dsX = StartX;
		dsY = StartY;
	//}
	
	int StartAndEndX, StartAndEndY, StartAndEndR, StartAndEndB, StartAndEndG;
	if (StartType == 4){
		//save start pixel
		StartAndEndX = StartX;
		StartAndEndY = StartY;
		StartAndEndB = StartB;
		StartAndEndG = StartG;
		StartAndEndR = StartType;
	}

	int centerX = StartX;
	int centerY = StartY;
	int eTempCenterX, eTempCenterY, mTempCenterX, mTempCenterY, gTempCenterX, gTempCenterY;
	
	bool notFinished = true;
	while (notFinished) {
		notFinished = false;
		
		//for print
		//int lastPixelType = pixels[centerX + centerY * (copy->w)].r;
		//int lastPixelB = pixels[centerX + centerY * (copy->w)].b;
		//int lastPixelG = pixels[centerX + centerY * (copy->w)].g;
				
		//delete old pixel along the way
		pixels[centerX + centerY * (copy->w)].r = 0;
		pixels[centerX + centerY * (copy->w)].b = 0;
		pixels[centerX + centerY * (copy->w)].g = 0;
		
		
		//std::cout << "Print all the neighbours: " << std::endl;
		bool mNaboFunnet = false; 
		bool eNaboFunnet = false;
		bool gNaboFunnet = false; 
		//Looping through the neighbours of the current pixel
		for (int i = -1; i < 2; i++) {
			for (int j = -1; j < 2; j++) {
			
				//int NType = pixels[(centerX + i) + (centerY + j) * (copy->w)].r;
				//int NPixelB = pixels[(centerX + i) + (centerY + j) * (copy->w)].b;
				//int NPixelG = pixels[(centerX + i) + (centerY + j) * (copy->w)].g;
				//int Nx = centerX + i;
				//int Ny = centerY + j;
				//std::cout << "Pixel x: " << Nx << " Pixel y: " << Ny << " B Value: " << NPixelB << " G Value: " << NPixelG << " Type: " << NType  << std::endl;
				
				int b = pixels[(centerX + i) + (centerY + j) * (copy->w)].b;
				int g = pixels[(centerX + i) + (centerY + j) * (copy->w)].g;
				int r = pixels[(centerX + i) + (centerY + j) * (copy->w)].r;
				
				//funni neste pixel
				if( b == StartB && g == StartG && r == 2){
				
					mNaboFunnet = true;
					//put as new center pixel
					mTempCenterX = centerX + i;
					mTempCenterY = centerY + j;
					notFinished = true;
					
				} 
				if( b == StartB && g == StartG && r == 3){
				
					eNaboFunnet = true;
					//put as new center pixel
					eTempCenterX = centerX + i;
					eTempCenterY = centerY + j;
					//notFinished = true;
					
				}
				if( b == StartB && g == StartG && r >= 6){
					//found gap pixel
					gNaboFunnet = true;
					//put as new center pixel
					gTempCenterX = centerX + i;
					gTempCenterY = centerY + j;
					notFinished = true;
				}
									
			}
		} //looping neighbors of current pixel finished
		
		//now it is time to use naboene vi fant
		if(mNaboFunnet){
			centerX = mTempCenterX;
			centerY = mTempCenterY;
			//utprint
			//int nextPixelType = pixels[(centerX) + (centerY) * (copy->w)].r;
			//int nextPixelB = pixels[(centerX) + (centerY) * (copy->w)].b;
			//int nextPixelG = pixels[(centerX) + (centerY) * (copy->w)].g;
			//std::cout << "M Pixel x: " << centerX << " y: " << centerY << " B Value: " << nextPixelB << " G Value: " << nextPixelG << " Type: " << nextPixelType  << std::endl;
			//draw
			deX = mTempCenterX;
			deY = mTempCenterY;
			counter++;
			XList[counter] = deX;
			YList[counter] = deY;
			if(ShouldIDrawLine(dsX, dsY, deX, deY, c1, c2, c3, counter, false, errorLimit)){
				//if yes sett dsX = deX
				dsX = deX;
				dsY = deY;
				counter = 0;
			}
			
		} else if(eNaboFunnet){
			centerX = eTempCenterX;
			centerY = eTempCenterY;
			//int nextPixelType = pixels[(centerX) + (centerY) * (copy->w)].r;
			//int nextPixelB = pixels[(centerX) + (centerY) * (copy->w)].b;
			//int nextPixelG = pixels[(centerX) + (centerY) * (copy->w)].g;
			//std::cout << "E Pixel x: " << centerX << " y: " << centerY << " B Value: " << nextPixelB << " G Value: " << nextPixelG << " Type: " << nextPixelType  << std::endl;
			//draw
			deX = eTempCenterX;
			deY = eTempCenterY;
			counter++;
			XList[counter] = deX;
			YList[counter] = deY;
			if(ShouldIDrawLine(dsX, dsY, deX, deY, c1, c2, c3, counter, true, errorLimit)){
				//if yes sett dsX = deX
				dsX = deX;
				dsY = deY;
				counter = 0;
			}
		} else if(gNaboFunnet){
			//ikke bare utprint her!
			int nextPixelType = pixels[(gTempCenterX) + (gTempCenterY) * (copy->w)].r;
			int nextPixelB = pixels[(gTempCenterX) + (gTempCenterY) * (copy->w)].b;
			int nextPixelG = pixels[(gTempCenterX) + (gTempCenterY) * (copy->w)].g;
			//std::cout << "Gap Pixel x: " << centerX << " y: " << centerY << " B Value: " << nextPixelB << " G Value: " << nextPixelG << " Type: " << nextPixelType  << std::endl;
			//draw
			deX = gTempCenterX;
			deY = gTempCenterY;
			counter++;
			XList[counter] = deX;
			YList[counter] = deY;
			if(ShouldIDrawLine(dsX, dsY, deX, deY, c1, c2, c3, counter, false, errorLimit)){
				//if yes sett dsX = deX
				dsX = deX;
				dsY = deY;
				counter = 0;
			}
			
			pixels[gTempCenterX + gTempCenterY * (copy->w)].r = 0;
			pixels[gTempCenterX + gTempCenterY * (copy->w)].b = 0;
			pixels[gTempCenterX + gTempCenterY * (copy->w)].g = 0;
			//search whole picture after matching G and set as center
			for (int r = 1; r < copy->w-1; r++) {
				for (int s = 1; s < copy->h-1; s++) {
					
					int gType = pixels[r + s * (copy->w)].r;
					int gB = pixels[r + s * (copy->w)].b;
					int gG = pixels[r + s * (copy->w)].g;
					
					if( gType == nextPixelType && gB == nextPixelB && gG == nextPixelG){
					
						//std::cout << "G nabo sin matchende G funnet!" << std::endl;
						centerX = r;
						centerY = s;
						//int nextPixelType = pixels[(centerX) + (centerY) * (copy->w)].r;
						//int nextPixelB = pixels[(centerX) + (centerY) * (copy->w)].b;
						//int nextPixelG = pixels[(centerX) + (centerY) * (copy->w)].g;
						//std::cout << "Gap Pixel x: " << centerX << " y: " << centerY << " B Value: " << nextPixelB << " G Value: " << nextPixelG << " Type: " << nextPixelType  << std::endl;
						//draw
						deX = centerX;
						deY = centerY;
						counter++;
						XList[counter] = deX;
						YList[counter] = deY;
						if(ShouldIDrawLine(dsX, dsY, deX, deY, c1, c2, c3, counter, false, errorLimit)){
							//if yes sett dsX = deX
							dsX = deX;
							dsY = deY;
							counter = 0;
						}
					}
				
				}
			}
			
		}
		
		if(!mNaboFunnet && !gNaboFunnet && StartType == 4){
			centerX = StartAndEndX;
			centerY = StartAndEndY;
			//int nextPixelType = StartAndEndR;
			//int nextPixelB = StartAndEndB;
			//int nextPixelG = StartAndEndG;
			//std::cout << "SaE Pixel x: " << centerX << " y: " << centerY << " B Value: " << nextPixelB << " G Value: " << nextPixelG << " Type: " << nextPixelType  << std::endl;
			//draw
			deX = centerX;
			deY = centerY;
			counter++;
			XList[counter] = deX;
			YList[counter] = deY;
			if(ShouldIDrawLine(dsX, dsY, deX, deY, c1, c2, c3, counter, true, errorLimit)){
				//if yes sett dsX = deX
				dsX = deX;
				dsY = deY;
				counter = 0;
			}
		}


	}//while is finished

	std::cout << "End of Edge! " << std::endl;
	std::cout << " " << std::endl;
}






//Funker perfekt, ikke mess
bool ShouldIDrawLineRegulary(int xStart, int yStart, int xEnd, int yEnd, float c1, float c2, float c3, int counter, bool endCordinate){

	if (counter >= 15){
		DrawLine(xStart, yStart, xEnd, yEnd, c1, c2, c3);
		counter = 0;
		return true;
	} else if (endCordinate) {
		DrawLine(xStart, yStart, xEnd, yEnd, c1, c2, c3);
		return true;
	}
	
	return false;
	
}

void DrawInputEdgeRegulary(SDL_Surface *copy, int StartX, int StartY, int errorLimit) {

	pixel * pixels = (pixel*) copy->pixels;
	
	float c1 = (float) rand()/RAND_MAX;
	float c2 = (float) rand()/RAND_MAX;
	float c3 = (float) rand()/RAND_MAX;
	
	int counter = 0;
	XList[counter] = StartX;
	YList[counter] = StartY;
	
	int StartType = pixels[StartX + StartY * (copy->w)].r;
	int StartB = pixels[StartX + StartY * (copy->w)].b;
	int StartG = pixels[StartX + StartY * (copy->w)].g;
	//the draw kordinates
	int dsX, dsY, deX, deY;
	if(StartB > 0 && StartG > 0){
		std::cout << "Pixel x: " << StartX << " y: " << StartY << " B Value: " << StartB << " G Value: " << StartG << " Type: " << StartType  << std::endl;
		//I tilegg til print, draw. Trenger start og stop kordinat, derfor ma forste pixel lagres for jeg kan draw
		dsX = StartX;
		dsY = StartY;
	}
	
	int StartAndEndX, StartAndEndY, StartAndEndR, StartAndEndB, StartAndEndG;
	if (StartType == 4){
		//save start pixel
		StartAndEndX = StartX;
		StartAndEndY = StartY;
		StartAndEndB = StartB;
		StartAndEndG = StartG;
		StartAndEndR = StartType;
	}

	int centerX = StartX;
	int centerY = StartY;
	int eTempCenterX, eTempCenterY, mTempCenterX, mTempCenterY, gTempCenterX, gTempCenterY;
	
	bool notFinished = true;
	while (notFinished) {
		notFinished = false;
		
		//for print
		//int lastPixelType = pixels[centerX + centerY * (copy->w)].r;
		//int lastPixelB = pixels[centerX + centerY * (copy->w)].b;
		//int lastPixelG = pixels[centerX + centerY * (copy->w)].g;
				
		//delete old pixel along the way
		pixels[centerX + centerY * (copy->w)].r = 0;
		pixels[centerX + centerY * (copy->w)].b = 0;
		pixels[centerX + centerY * (copy->w)].g = 0;
		
		
		//std::cout << "Print all the neighbours: " << std::endl;
		bool mNaboFunnet = false; 
		bool eNaboFunnet = false;
		bool gNaboFunnet = false; 
		//Looping through the neighbours of the current pixel
		for (int i = -1; i < 2; i++) {
			for (int j = -1; j < 2; j++) {
			
				//int NType = pixels[(centerX + i) + (centerY + j) * (copy->w)].r;
				//int NPixelB = pixels[(centerX + i) + (centerY + j) * (copy->w)].b;
				//int NPixelG = pixels[(centerX + i) + (centerY + j) * (copy->w)].g;
				//int Nx = centerX + i;
				//int Ny = centerY + j;
				//std::cout << "Pixel x: " << Nx << " Pixel y: " << Ny << " B Value: " << NPixelB << " G Value: " << NPixelG << " Type: " << NType  << std::endl;
				
				int b = pixels[(centerX + i) + (centerY + j) * (copy->w)].b;
				int g = pixels[(centerX + i) + (centerY + j) * (copy->w)].g;
				int r = pixels[(centerX + i) + (centerY + j) * (copy->w)].r;
				
				//funni neste pixel
				if( b == StartB && g == StartG && r == 2){
				
					mNaboFunnet = true;
					//put as new center pixel
					mTempCenterX = centerX + i;
					mTempCenterY = centerY + j;
					notFinished = true;
					
				} 
				if( b == StartB && g == StartG && r == 3){
				
					eNaboFunnet = true;
					//put as new center pixel
					eTempCenterX = centerX + i;
					eTempCenterY = centerY + j;
					//notFinished = true;
					
				}
				if( b == StartB && g == StartG && r >= 6){
					//found gap pixel
					gNaboFunnet = true;
					//put as new center pixel
					gTempCenterX = centerX + i;
					gTempCenterY = centerY + j;
					notFinished = true;
				}
									
			}
		} //looping neighbors of current pixel finished
		
		//now it is time to use naboene vi fant
		if(mNaboFunnet){
			centerX = mTempCenterX;
			centerY = mTempCenterY;
			//utprint
			int nextPixelType = pixels[(centerX) + (centerY) * (copy->w)].r;
			int nextPixelB = pixels[(centerX) + (centerY) * (copy->w)].b;
			int nextPixelG = pixels[(centerX) + (centerY) * (copy->w)].g;
			std::cout << "M Pixel x: " << centerX << " y: " << centerY << " B Value: " << nextPixelB << " G Value: " << nextPixelG << " Type: " << nextPixelType  << std::endl;
			//draw
			deX = mTempCenterX;
			deY = mTempCenterY;
			counter++;
			XList[counter] = deX;
			YList[counter] = deY;
			if(ShouldIDrawLine(dsX, dsY, deX, deY, c1, c2, c3, counter, false, errorLimit)){
				//if yes sett dsX = deX
				dsX = deX;
				dsY = deY;
				counter = 0;
			}
			
		} else if(eNaboFunnet){
			centerX = eTempCenterX;
			centerY = eTempCenterY;
			int nextPixelType = pixels[(centerX) + (centerY) * (copy->w)].r;
			int nextPixelB = pixels[(centerX) + (centerY) * (copy->w)].b;
			int nextPixelG = pixels[(centerX) + (centerY) * (copy->w)].g;
			std::cout << "E Pixel x: " << centerX << " y: " << centerY << " B Value: " << nextPixelB << " G Value: " << nextPixelG << " Type: " << nextPixelType  << std::endl;
			//draw
			deX = eTempCenterX;
			deY = eTempCenterY;
			counter++;
			XList[counter] = deX;
			YList[counter] = deY;
			if(ShouldIDrawLine(dsX, dsY, deX, deY, c1, c2, c3, counter, true, errorLimit)){
				//if yes sett dsX = deX
				dsX = deX;
				dsY = deY;
				counter = 0;
			}
		} else if(gNaboFunnet){
			//ikke bare utprint her!
			int nextPixelType = pixels[(gTempCenterX) + (gTempCenterY) * (copy->w)].r;
			int nextPixelB = pixels[(gTempCenterX) + (gTempCenterY) * (copy->w)].b;
			int nextPixelG = pixels[(gTempCenterX) + (gTempCenterY) * (copy->w)].g;
			std::cout << "Gap Pixel x: " << centerX << " y: " << centerY << " B Value: " << nextPixelB << " G Value: " << nextPixelG << " Type: " << nextPixelType  << std::endl;
			//draw
			deX = gTempCenterX;
			deY = gTempCenterY;
			counter++;
			XList[counter] = deX;
			YList[counter] = deY;
			if(ShouldIDrawLine(dsX, dsY, deX, deY, c1, c2, c3, counter, false, errorLimit)){
				//if yes sett dsX = deX
				dsX = deX;
				dsY = deY;
				counter = 0;
			}
			
			pixels[gTempCenterX + gTempCenterY * (copy->w)].r = 0;
			pixels[gTempCenterX + gTempCenterY * (copy->w)].b = 0;
			pixels[gTempCenterX + gTempCenterY * (copy->w)].g = 0;
			//search whole picture after matching G and set as center
			for (int r = 1; r < copy->w-1; r++) {
				for (int s = 1; s < copy->h-1; s++) {
					
					int gType = pixels[r + s * (copy->w)].r;
					int gB = pixels[r + s * (copy->w)].b;
					int gG = pixels[r + s * (copy->w)].g;
					
					if( gType == nextPixelType && gB == nextPixelB && gG == nextPixelG){
					
						std::cout << "G nabo sin matchende G funnet!" << std::endl;
						centerX = r;
						centerY = s;
						int nextPixelType = pixels[(centerX) + (centerY) * (copy->w)].r;
						int nextPixelB = pixels[(centerX) + (centerY) * (copy->w)].b;
						int nextPixelG = pixels[(centerX) + (centerY) * (copy->w)].g;
						std::cout << "Gap Pixel x: " << centerX << " y: " << centerY << " B Value: " << nextPixelB << " G Value: " << nextPixelG << " Type: " << nextPixelType  << std::endl;
						//draw
						deX = centerX;
						deY = centerY;
						counter++;
						XList[counter] = deX;
						YList[counter] = deY;
						if(ShouldIDrawLine(dsX, dsY, deX, deY, c1, c2, c3, counter, false, errorLimit)){
							//if yes sett dsX = deX
							dsX = deX;
							dsY = deY;
							counter = 0;
						}
					}
				
				}
			}
			
		}
		
		if(!mNaboFunnet && !gNaboFunnet && StartType == 4 && StartAndEndB > 0 && StartAndEndG > 0){
			centerX = StartAndEndX;
			centerY = StartAndEndY;
			int nextPixelType = StartAndEndR;
			int nextPixelB = StartAndEndB;
			int nextPixelG = StartAndEndG;
			std::cout << "SaE Pixel x: " << centerX << " y: " << centerY << " B Value: " << nextPixelB << " G Value: " << nextPixelG << " Type: " << nextPixelType  << std::endl;
			//draw
			deX = centerX;
			deY = centerY;
			counter++;
			XList[counter] = deX;
			YList[counter] = deY;
			if(ShouldIDrawLine(dsX, dsY, deX, deY, c1, c2, c3, counter, true, errorLimit)){
				//if yes sett dsX = deX
				dsX = deX;
				dsY = deY;
				counter = 0;
			}
		}


	}//while is finished

	std::cout << "End of Edge! " << std::endl;
	std::cout << " " << std::endl;
}

//funker nesten perfekt
void DrawInputEdgeDirect(SDL_Surface *copy, int StartX, int StartY, int errorLimit) {

	pixel * pixels = (pixel*) copy->pixels;
	
	float c1 = (float) rand()/RAND_MAX;
	float c2 = (float) rand()/RAND_MAX;
	float c3 = (float) rand()/RAND_MAX;
	
	int StartType = pixels[StartX + StartY * (copy->w)].r;
	int StartB = pixels[StartX + StartY * (copy->w)].b;
	int StartG = pixels[StartX + StartY * (copy->w)].g;
	//the draw kordinates
	int dsX, dsY, deX, deY;
	if(StartB > 0 && StartG > 0){
		std::cout << "Pixel x: " << StartX << " y: " << StartY << " B Value: " << StartB << " G Value: " << StartG << " Type: " << StartType  << std::endl;
		//I tilegg til print, draw. Trenger start og stop kordinat, derfor ma forste pixel lagres for jeg kan draw
		dsX = StartX;
		dsY = StartY;
	}
	
	int StartAndEndX, StartAndEndY, StartAndEndR, StartAndEndB, StartAndEndG;
	if (StartType == 4){
		//save start pixel
		StartAndEndX = StartX;
		StartAndEndY = StartY;
		StartAndEndB = StartB;
		StartAndEndG = StartG;
		StartAndEndR = StartType;
	}

	int centerX = StartX;
	int centerY = StartY;
	int eTempCenterX, eTempCenterY, mTempCenterX, mTempCenterY, gTempCenterX, gTempCenterY;
	
	bool notFinished = true;
	while (notFinished) {
		notFinished = false;
		
		//for print
		//int lastPixelType = pixels[centerX + centerY * (copy->w)].r;
		//int lastPixelB = pixels[centerX + centerY * (copy->w)].b;
		//int lastPixelG = pixels[centerX + centerY * (copy->w)].g;
				
		//delete old pixel along the way
		pixels[centerX + centerY * (copy->w)].r = 0;
		pixels[centerX + centerY * (copy->w)].b = 0;
		pixels[centerX + centerY * (copy->w)].g = 0;
		
		
		//std::cout << "Print all the neighbours: " << std::endl;
		bool mNaboFunnet = false; 
		bool eNaboFunnet = false;
		bool gNaboFunnet = false; 
		//Looping through the neighbours of the current pixel
		for (int i = -1; i < 2; i++) {
			for (int j = -1; j < 2; j++) {
			
				//int NType = pixels[(centerX + i) + (centerY + j) * (copy->w)].r;
				//int NPixelB = pixels[(centerX + i) + (centerY + j) * (copy->w)].b;
				//int NPixelG = pixels[(centerX + i) + (centerY + j) * (copy->w)].g;
				//int Nx = centerX + i;
				//int Ny = centerY + j;
				//std::cout << "Pixel x: " << Nx << " Pixel y: " << Ny << " B Value: " << NPixelB << " G Value: " << NPixelG << " Type: " << NType  << std::endl;
				
				int b = pixels[(centerX + i) + (centerY + j) * (copy->w)].b;
				int g = pixels[(centerX + i) + (centerY + j) * (copy->w)].g;
				int r = pixels[(centerX + i) + (centerY + j) * (copy->w)].r;
				
				//funni neste pixel
				if( b == StartB && g == StartG && r == 2){
				
					mNaboFunnet = true;
					//put as new center pixel
					mTempCenterX = centerX + i;
					mTempCenterY = centerY + j;
					notFinished = true;
					
				} 
				if( b == StartB && g == StartG && r == 3){
				
					eNaboFunnet = true;
					//put as new center pixel
					eTempCenterX = centerX + i;
					eTempCenterY = centerY + j;
					//notFinished = true;
					
				}
				if( b == StartB && g == StartG && r >= 6){
					//found gap pixel
					gNaboFunnet = true;
					//put as new center pixel
					gTempCenterX = centerX + i;
					gTempCenterY = centerY + j;
					notFinished = true;
				}
									
			}
		} //looping neighbors of current pixel finished
		
		//now it is time to use naboene vi fant
		if(mNaboFunnet){
			centerX = mTempCenterX;
			centerY = mTempCenterY;
			//utprint
			int nextPixelType = pixels[(centerX) + (centerY) * (copy->w)].r;
			int nextPixelB = pixels[(centerX) + (centerY) * (copy->w)].b;
			int nextPixelG = pixels[(centerX) + (centerY) * (copy->w)].g;
			std::cout << "M Pixel x: " << centerX << " y: " << centerY << " B Value: " << nextPixelB << " G Value: " << nextPixelG << " Type: " << nextPixelType  << std::endl;
			//draw
			deX = mTempCenterX;
			deY = mTempCenterY;
			DrawLine(dsX, dsY, deX, deY, c1, c2, c3);
			dsX = deX;
			dsY = deY;
			
		} else if(eNaboFunnet){
			centerX = eTempCenterX;
			centerY = eTempCenterY;
			int nextPixelType = pixels[(centerX) + (centerY) * (copy->w)].r;
			int nextPixelB = pixels[(centerX) + (centerY) * (copy->w)].b;
			int nextPixelG = pixels[(centerX) + (centerY) * (copy->w)].g;
			std::cout << "E Pixel x: " << centerX << " y: " << centerY << " B Value: " << nextPixelB << " G Value: " << nextPixelG << " Type: " << nextPixelType  << std::endl;
			//draw
			deX = eTempCenterX;
			deY = eTempCenterY;
			DrawLine(dsX, dsY, deX, deY, c1, c2, c3);
			dsX = deX;
			dsY = deY;
		} else if(gNaboFunnet){
			//ikke bare utprint her!
			int nextPixelType = pixels[(gTempCenterX) + (gTempCenterY) * (copy->w)].r;
			int nextPixelB = pixels[(gTempCenterX) + (gTempCenterY) * (copy->w)].b;
			int nextPixelG = pixels[(gTempCenterX) + (gTempCenterY) * (copy->w)].g;
			std::cout << "Gap Pixel x: " << centerX << " y: " << centerY << " B Value: " << nextPixelB << " G Value: " << nextPixelG << " Type: " << nextPixelType  << std::endl;
			//draw
			deX = gTempCenterX;
			deY = gTempCenterY;
			DrawLine(dsX, dsY, deX, deY, c1, c2, c3);
			dsX = deX;
			dsY = deY;
			pixels[gTempCenterX + gTempCenterY * (copy->w)].r = 0;
			pixels[gTempCenterX + gTempCenterY * (copy->w)].b = 0;
			pixels[gTempCenterX + gTempCenterY * (copy->w)].g = 0;
			//search whole picture after matching G and set as center
			for (int r = 1; r < copy->w-1; r++) {
				for (int s = 1; s < copy->h-1; s++) {
					
					int gType = pixels[r + s * (copy->w)].r;
					int gB = pixels[r + s * (copy->w)].b;
					int gG = pixels[r + s * (copy->w)].g;
					
					if( gType == nextPixelType && gB == nextPixelB && gG == nextPixelG){
					
						std::cout << "G nabo sin matchende G funnet!" << std::endl;
						centerX = r;
						centerY = s;
						int nextPixelType = pixels[(centerX) + (centerY) * (copy->w)].r;
						int nextPixelB = pixels[(centerX) + (centerY) * (copy->w)].b;
						int nextPixelG = pixels[(centerX) + (centerY) * (copy->w)].g;
						std::cout << "Gap Pixel x: " << centerX << " y: " << centerY << " B Value: " << nextPixelB << " G Value: " << nextPixelG << " Type: " << nextPixelType  << std::endl;
						//draw
						deX = centerX;
						deY = centerY;
						DrawLine(dsX, dsY, deX, deY, c1, c2, c3);
						dsX = deX;
						dsY = deY;
					}
				
				}
			}
			
		}
		
		if(!mNaboFunnet && !gNaboFunnet && StartType == 4 && StartAndEndB > 0 && StartAndEndG > 0){
			centerX = StartAndEndX;
			centerY = StartAndEndY;
			int nextPixelType = StartAndEndR;
			int nextPixelB = StartAndEndB;
			int nextPixelG = StartAndEndG;
			std::cout << "SaE Pixel x: " << centerX << " y: " << centerY << " B Value: " << nextPixelB << " G Value: " << nextPixelG << " Type: " << nextPixelType  << std::endl;
			//draw
			deX = centerX;
			deY = centerY;
			DrawLine(dsX, dsY, deX, deY, c1, c2, c3);
			dsX = deX;
			dsY = deY;
		}


	}//while is finished

	std::cout << "End of Edge! " << std::endl;
	std::cout << " " << std::endl;
}


//ALT FUNKER PERFEKT! Lagre som er
void PrintInputEdge(SDL_Surface *copy, int StartX, int StartY, int errorLimit) {

	pixel * pixels = (pixel*) copy->pixels;
	
	int StartType = pixels[StartX + StartY * (copy->w)].r;
	int StartB = pixels[StartX + StartY * (copy->w)].b;
	int StartG = pixels[StartX + StartY * (copy->w)].g;
	if(StartB > 0 && StartG > 0){
		std::cout << "Pixel x: " << StartX << " y: " << StartY << " B Value: " << StartB << " G Value: " << StartG << " Type: " << StartType  << std::endl;
	}
	
	int StartAndEndX, StartAndEndY, StartAndEndR, StartAndEndB, StartAndEndG;
	if (StartType == 4){
		//save start pixel
		StartAndEndX = StartX;
		StartAndEndY = StartY;
		StartAndEndB = StartB;
		StartAndEndG = StartG;
		StartAndEndR = StartType;
	}

	int centerX = StartX;
	int centerY = StartY;
	int eTempCenterX, eTempCenterY, mTempCenterX, mTempCenterY, gTempCenterX, gTempCenterY;
	
	bool notFinished = true;
	while (notFinished) {
		notFinished = false;
		
		//for print
		//int lastPixelType = pixels[centerX + centerY * (copy->w)].r;
		//int lastPixelB = pixels[centerX + centerY * (copy->w)].b;
		//int lastPixelG = pixels[centerX + centerY * (copy->w)].g;
				
		//delete old pixel along the way
		pixels[centerX + centerY * (copy->w)].r = 0;
		pixels[centerX + centerY * (copy->w)].b = 0;
		pixels[centerX + centerY * (copy->w)].g = 0;
		
		
		//std::cout << "Print all the neighbours: " << std::endl;
		bool mNaboFunnet = false; 
		bool eNaboFunnet = false;
		bool gNaboFunnet = false; 
		//Looping through the neighbours of the current pixel
		for (int i = -1; i < 2; i++) {
			for (int j = -1; j < 2; j++) {
			
				//int NType = pixels[(centerX + i) + (centerY + j) * (copy->w)].r;
				//int NPixelB = pixels[(centerX + i) + (centerY + j) * (copy->w)].b;
				//int NPixelG = pixels[(centerX + i) + (centerY + j) * (copy->w)].g;
				//int Nx = centerX + i;
				//int Ny = centerY + j;
				//std::cout << "Pixel x: " << Nx << " Pixel y: " << Ny << " B Value: " << NPixelB << " G Value: " << NPixelG << " Type: " << NType  << std::endl;
				
				int b = pixels[(centerX + i) + (centerY + j) * (copy->w)].b;
				int g = pixels[(centerX + i) + (centerY + j) * (copy->w)].g;
				int r = pixels[(centerX + i) + (centerY + j) * (copy->w)].r;
				
				//funni neste pixel
				if( b == StartB && g == StartG && r == 2){
				
					mNaboFunnet = true;
					//put as new center pixel
					mTempCenterX = centerX + i;
					mTempCenterY = centerY + j;
					notFinished = true;
					
				} 
				if( b == StartB && g == StartG && r == 3){
				
					eNaboFunnet = true;
					//put as new center pixel
					eTempCenterX = centerX + i;
					eTempCenterY = centerY + j;
					//notFinished = true;
					
				}
				if( b == StartB && g == StartG && r >= 6){
					//found gap pixel
					gNaboFunnet = true;
					//put as new center pixel
					gTempCenterX = centerX + i;
					gTempCenterY = centerY + j;
					notFinished = true;
				}
									
			}
		} //looping neighbors of current pixel finished
		
		//now it is time to use naboene vi fant
		if(mNaboFunnet){
			centerX = mTempCenterX;
			centerY = mTempCenterY;
			//utprint
			int nextPixelType = pixels[(centerX) + (centerY) * (copy->w)].r;
			int nextPixelB = pixels[(centerX) + (centerY) * (copy->w)].b;
			int nextPixelG = pixels[(centerX) + (centerY) * (copy->w)].g;
			std::cout << "M Pixel x: " << centerX << " y: " << centerY << " B Value: " << nextPixelB << " G Value: " << nextPixelG << " Type: " << nextPixelType  << std::endl;
		} else if(eNaboFunnet){
			centerX = eTempCenterX;
			centerY = eTempCenterY;
			int nextPixelType = pixels[(centerX) + (centerY) * (copy->w)].r;
			int nextPixelB = pixels[(centerX) + (centerY) * (copy->w)].b;
			int nextPixelG = pixels[(centerX) + (centerY) * (copy->w)].g;
			std::cout << "E Pixel x: " << centerX << " y: " << centerY << " B Value: " << nextPixelB << " G Value: " << nextPixelG << " Type: " << nextPixelType  << std::endl;
		} else if(gNaboFunnet){
			//ikke bare utprint her!
			int nextPixelType = pixels[(gTempCenterX) + (gTempCenterY) * (copy->w)].r;
			int nextPixelB = pixels[(gTempCenterX) + (gTempCenterY) * (copy->w)].b;
			int nextPixelG = pixels[(gTempCenterX) + (gTempCenterY) * (copy->w)].g;
			std::cout << "Gap Pixel x: " << centerX << " y: " << centerY << " B Value: " << nextPixelB << " G Value: " << nextPixelG << " Type: " << nextPixelType  << std::endl;
			pixels[gTempCenterX + gTempCenterY * (copy->w)].r = 0;
			pixels[gTempCenterX + gTempCenterY * (copy->w)].b = 0;
			pixels[gTempCenterX + gTempCenterY * (copy->w)].g = 0;
			//search whole picture after matching G and set as center
			for (int r = 1; r < copy->w-1; r++) {
				for (int s = 1; s < copy->h-1; s++) {
					
					int gType = pixels[r + s * (copy->w)].r;
					int gB = pixels[r + s * (copy->w)].b;
					int gG = pixels[r + s * (copy->w)].g;
					
					if( gType == nextPixelType && gB == nextPixelB && gG == nextPixelG){
					
						std::cout << "G nabo sin matchende G funnet!" << std::endl;
						centerX = r;
						centerY = s;
						int nextPixelType = pixels[(centerX) + (centerY) * (copy->w)].r;
						int nextPixelB = pixels[(centerX) + (centerY) * (copy->w)].b;
						int nextPixelG = pixels[(centerX) + (centerY) * (copy->w)].g;
						std::cout << "Gap Pixel x: " << centerX << " y: " << centerY << " B Value: " << nextPixelB << " G Value: " << nextPixelG << " Type: " << nextPixelType  << std::endl;
					}
				
				}
			}
			
		}
		
		if(!mNaboFunnet && !gNaboFunnet && StartType == 4 && StartAndEndB > 0 && StartAndEndG > 0){
			centerX = StartAndEndX;
			centerY = StartAndEndY;
			int nextPixelType = StartAndEndR;
			int nextPixelB = StartAndEndB;
			int nextPixelG = StartAndEndG;
			std::cout << "SaE Pixel x: " << centerX << " y: " << centerY << " B Value: " << nextPixelB << " G Value: " << nextPixelG << " Type: " << nextPixelType  << std::endl;
		}


	}//while is finished

	std::cout << "End of Edge! " << std::endl;
	std::cout << " " << std::endl;
}


float ComputePolygonError(int lineStartX, int lineStartY, int lineMiddleX, int lineMiddleY, int lineStopX, int lineStopY, float errorLimit){

	//std::cout << "SX: " << lineStartX << " SY: " << lineStartY  << " MX: " << lineMiddleX << " MY: " << lineMiddleY << " EX: " << lineStopX << " EY: " << lineStopY << std::endl; //Ok

	//compute the sides of the triangel
	float side1 = ComputeTriangelSide(lineStartX, lineStartY, lineMiddleX, lineMiddleY);
	float side2 = ComputeTriangelSide(lineMiddleX, lineMiddleY, lineStopX, lineStopY);
	float side3 = ComputeTriangelSide(lineStopX, lineStopY, lineStartX, lineStartY);
	
	//input ma vare mellom -1 og 1! ellers feil
	float inputToAcos = (pow(side1, 2) + pow(side3, 2) - pow(side2, 2)) / (2*side1*side3);
	if (inputToAcos > 1 || inputToAcos < -1){
		//std::cout << "kan gi nan " << std::endl;
		inputToAcos = 1; //vil ende opp i error = errorLimit + 1;
	}
	float lineStartAngel = acos(inputToAcos); // in radians, the output and input of cos() osv.. for degrees *(180/PI)
	
	float angel = lineStartAngel * (180/PI);
	//std::cout << "Line Start angel is: " << angel << std::endl;
	
	float error; //h
	if (angel < 90){	//the M is between S and E
		//h = abs(sin(lineStartAngel)*side1); //ikke abs bedre?
		error = sin(lineStartAngel)*side1;
		//std::cout << "Kommer hit! Error is: " << h << std::endl;
	} else { // M is not between S and E and the error is to big! Set it to to big!
		error = errorLimit + 1;
	}

	return error ;	
}

float ComputeAngel(int lineStartX, int lineStartY, int lineMiddleX, int lineMiddleY, int lineStopX, int lineStopY){

	//computes the angel to the first x, y (lineStartX and LineStartY)
	//compute the sides of the triangel
	float side1 = ComputeTriangelSide(lineStartX, lineStartY, lineMiddleX, lineMiddleY);
	float side2 = ComputeTriangelSide(lineMiddleX, lineMiddleY, lineStopX, lineStopY);
	float side3 = ComputeTriangelSide(lineStopX, lineStopY, lineStartX, lineStartY);
	
	//input ma vare mellom -1 og 1! ellers feil
	float inputToAcos = (pow(side1, 2) + pow(side3, 2) - pow(side2, 2)) / (2*side1*side3);
	if (inputToAcos > 1 || inputToAcos < -1){
		//std::cout << "kan gi nan " << std::endl;
		//velg at input skal vare -1, slik at output blir 180! Noe som tilsvarer graden til en linje
		inputToAcos = -1;
	}
	float lineStartAngel = acos(inputToAcos); // in radians, the output and input of cos() osv.. for degrees *(180/PI)
	float angel = lineStartAngel * (180/PI); //Fiksa nan problem! haper ting er riktig
	
	return angel ;	
}


float ComputeTriangelSide(int lineStartX, int lineStartY, int lineStopX, int lineStopY){

	//distance between two points A(x1, y1) and B(x2, y2) is square root of sqrt((x2-x1)powerof2 + (y2-y1powerof2)) where powerof2 can be written pow(base,exponent)	
	return sqrt( abs( (pow(lineStopX-lineStartX, 2)) + (pow(lineStopY-lineStartY, 2)) ));
}

