/*
 *  draw_edges.h
 *
 *  Created by Kari Haugsdal
 */

#ifndef DRAW_EDGES_H
#define DRAW_EDGES_H

#include "definitions.h"
#include <math.h>
#define PI 3.14159265

void DrawLine(int xStart, int yStart, int xEnd, int yEnd, float c1, float c2, float c3);

bool ShouldIDrawLine(int xStart, int yStart, int xEnd, int yEnd, float c1, float c2, float c3, int counter,  bool endCordinate,  float limit);
void DrawEdge(SDL_Surface *copy, int StartX, int StartY, int errorLimit, float c1, float c2, float c3);

bool ShouldIDrawLineQuestion(int xStart, int yStart, int xEnd, int yEnd, int xOld, int yOld, int counter, bool endCordinate, float limit);
bool CornerFound(int xStart, int yStart, int xEnd, int yEnd, int xOld, int yOld, int counter, bool endCordinate, float limit, int cornerLimit);
bool StrictCornerFound(int xStart, int yStart, int xEnd, int yEnd, int xOld, int yOld, int counter, bool endCordinate, float limit, int cornerLimit);
bool ZigZag(int xStart, int yStart, int xEnd, int yEnd, int xOld, int yOld, int xXOld, int yXOld);
int ShapeRecognition(SDL_Surface *copy, int StartX, int StartY, int errorLimit, float c1, float c2, float c3, int cornerLimit, int strictCornerLimit, int smalestDegreeTriangel, int squareSideLimit);

bool ShouldIDrawLinePoly(int xStart, int yStart, int xEnd, int yEnd, float c1, float c2, float c3, int counter,  bool endCordinate,  float limit);
void DrawInputEdgePoly(SDL_Surface *copy, int StartX, int StartY, int errorLimit);
bool ShouldIDrawLineRegulary(int xStart, int yStart, int xEnd, int yEnd, float c1, float c2, float c3, int counter,  bool endCordinate);
void DrawInputEdgeRegulary(SDL_Surface *copy, int StartX, int StartY, int errorLimit);
void DrawInputEdgeDirect(SDL_Surface *copy, int StartX, int StartY, int errorLimit);
void PrintInputEdge(SDL_Surface *copy, int StartX, int StartY, int errorLimit);

float ComputePolygonError(int lineStartX, int lineStartY, int lineMiddleX, int lineMiddleY, int lineStopX, int lineStopY, float errorLimit);
float ComputeAngel(int lineStartX, int lineStartY, int lineMiddleX, int lineMiddleY, int lineStopX, int lineStopY);
float ComputeTriangelSide(int lineStartX, int lineStartY, int lineStopX, int lineStopY);

#endif

