//#include "image_example.h"
#include "SDL.h"
#include "SDL_opengl.h"		// platform independent OpenGL include
#include <stdio.h>			// Allows us to work with files
#include <iostream>
#include "definitions.h"
#include "draw_edges.h"

void DrawEdges(SDL_Surface *image, SDL_Surface *copy, int pictureWidth, int pictureHight)
{

	int biggestOfWandH;
	if( pictureWidth >=  pictureHight){
		biggestOfWandH = pictureWidth + (pictureHight/2);
	} else {
		biggestOfWandH = pictureHight + (pictureWidth/2);
	}

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);		// Clear The Screen And The Depth Buffer
	glLoadIdentity();										// Reset The View
	glTranslatef(-(pictureWidth/2), pictureHight/2, -biggestOfWandH);	
	
	pixel * pixels = (pixel*) image->pixels;
	pixel * copyPixels = (pixel*) copy->pixels;
	
	//empty copy picture for saving purposess, that is make entire picture black
	for (int x = 0; x < image->w; x++) {
		for (int y = 0; y < image->h; y++) {
			copyPixels[x + y * (image->w)].r = 0;
			copyPixels[x + y * (image->w)].b = 0;
			copyPixels[x + y * (image->w)].g = 0;
		}
	}
	
	int counter = 0;
	for (int x = 0; x < image->w; x++) {
		for (int y = 0; y < image->h; y++) {
		
			int start = 1;
			int startAndEnd = 4;
			
			//We found a start pixel to an edge
			if(pixels[x + y * (image->w)].r == start || pixels[x + y * (image->w)].r == startAndEnd){
			
				counter++; //found an edge start
				int edgeBValue = pixels[x + y * (image->w)].b;
				int edgeGValue = pixels[x + y * (image->w)].g;
				
				//Go through the whole picture and find the edge with this value
				for (int k = 0; k < image->w; k++) {
					for (int l = 0; l < image->h; l++) {
					
						if(pixels[k + l * (image->w)].b == edgeBValue && pixels[k + l * (image->w)].g == edgeGValue){
						
							//send edge to copy
							copyPixels[k + l * (image->w)].r = pixels[k + l * (image->w)].r;
							copyPixels[k + l * (image->w)].b = pixels[k + l * (image->w)].b;
							copyPixels[k + l * (image->w)].g = pixels[k + l * (image->w)].g;
						}
					}
				}
				
				//set some random color first
				float c1 = (float) rand()/RAND_MAX;
				float c2 = (float) rand()/RAND_MAX;
				float c3 = (float) rand()/RAND_MAX;
				
				//inputt verdier! Likt for alle bilder, sa finn noen gode
				//2, 158, 18, 10, og 6 gir best resultat shapes bildet
				float questionErrorLimitPolygonAdaption = 4;  //hvor kantete jeg vil ha bildet ves shape detection
				float errorLimitPolygonAdaption = 1;  //hvor kantete jeg vil ha bildet
				
				int cornerLimit = 158; //helst litt mer en 90 for parabler og litt fleksibilitet (158 gir vanskelig firkant rod verdi i shapes) 110 er ok ogsa
				
				//restrictions on lines, triangels and squares
				int strictCornerLimit = 13;
				int smalestDegreeTriangel = 10;
				int squareSideLimit = 6;
				
				//DRAW the edge using the copy!
				int info = ShapeRecognition(copy, x, y, questionErrorLimitPolygonAdaption, c1, c2, c3, cornerLimit, strictCornerLimit, smalestDegreeTriangel, squareSideLimit);
				//std::cout << "Info: " << info << std::endl;
				//std::cout << " " << std::endl;
				
				//copy blir tomt! Fyll opp igjen
				//Go through the whole picture and find the edge with this value
				for (int k = 0; k < image->w; k++) {
					for (int l = 0; l < image->h; l++) {
						if(pixels[k + l * (image->w)].b == edgeBValue && pixels[k + l * (image->w)].g == edgeGValue){
							//send edge to copy
							copyPixels[k + l * (image->w)].r = pixels[k + l * (image->w)].r;
							copyPixels[k + l * (image->w)].b = pixels[k + l * (image->w)].b;
							copyPixels[k + l * (image->w)].g = pixels[k + l * (image->w)].g;
						}
					}
				}
				
				if (info == 0){ //straight line
					DrawEdge(copy, x, y,  errorLimitPolygonAdaption, 1, 0, 1); //lilla
				} 
				else if (info == 1){ //semi straight line?
					DrawEdge(copy, x, y,  errorLimitPolygonAdaption, 0, 1, 0); //green
				} 
				else if (info == 2){ //line
					DrawEdge(copy, x, y,  errorLimitPolygonAdaption, 0, 1, 0); //green
				} 
				else if (info == 3){ //triangel
					DrawEdge(copy, x, y,  errorLimitPolygonAdaption, 1, 1, 0); //yellow
				}				
				else if (info == 4){ //square
					DrawEdge(copy, x, y,  errorLimitPolygonAdaption, 1, 0, 0); //red
				}
				else if (info == 5){ //blobb
					//draw again not highliting
					DrawEdge(copy, x, y,  errorLimitPolygonAdaption, 0, 0, 1);//blue
				}
				else { //everything else
					//draw again not highliting
					DrawEdge(copy, x, y,  errorLimitPolygonAdaption, 0, 1, 0);//green
				}
				//emty copy, so that the program can send one and one edge
				for (int x = 0; x < image->w; x++) {
					for (int y = 0; y < image->h; y++) {
						copyPixels[x + y * (image->w)].r = 0;
						copyPixels[x + y * (image->w)].b = 0;
						copyPixels[x + y * (image->w)].g = 0;
					}
				}
			
			}//we found a start pixel finished
					
		}
	}//going true the whole picture finished
	
	//std::cout << "Number of edges: " << counter << std::endl;
		
}


void DrawTriangle()
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);		// Clear The Screen And The Depth Buffer
	glLoadIdentity();										// Reset The View
	glTranslatef(0.0f,0.0f,-6.0f);							// Move Into The Screen 6.0

	glColor3f(0.5f,0.5f,1.0f);				// Set The Color To Blue One Time Only
	glBegin(GL_LINES);						// Drawing Using Triangles
		glVertex3f( 0.0f, 1.0f, 0.0f);				// Top
		glVertex3f(-1.0f,-1.0f, 0.0f);				// Bottom Left
	glEnd();
	glColor3f(1.0f,0.0f,0.0f);			// Set The Color To Red
	glBegin(GL_LINES);						// Drawing Using Triangles
		glVertex3f(-1.0f,-1.0f, 0.0f);				// Bottom Left
		glVertex3f( 1.0f,-1.0f, 0.0f);				// Bottom Right
	glEnd();
	glColor3f(0.0f,1.0f,0.0f);			// Set The Color To Green
	glBegin(GL_LINES);						// Drawing Using Triangles
		glVertex3f(1.0f,-1.0f, 0.0f);				// Bottom Left
		glVertex3f( 0.0f, 1.0f, 0.0f);				// Bottom Right
	glEnd();

}

int lytt(){
	int tilbake = 0;
	SDL_Event event;
      while ( SDL_PollEvent(&event) ) {
        if ( event.type == SDL_QUIT ) {
          tilbake = 1;
        }
        if ( event.type == SDL_KEYDOWN ) {
          if ( event.key.keysym.sym == SDLK_ESCAPE ) {
            tilbake = 1;
          }
        }
      }
  return tilbake;
}

void LoadBMP(const char *filename, SDL_Surface *surface) {
  // Load BMP file
  SDL_Surface* image=SDL_LoadBMP(filename);
  if (!image) {
    fprintf(stderr, "Couldn't load %s: %s\n", filename, SDL_GetError());
    return;
  }
  SDL_Rect area = {0, 0, image->w, image->h};

  // Copy loaded bitmap to surface
  SDL_BlitSurface(image, NULL, surface, &area);
  SDL_FreeSurface(image);
}

int main (int argc, char **argv) {

	
	//taking the picture path and size as input
	std::cout << "Please enter picture path: ";
	std::string name;
	std::cin >> name;
	const char* pictureName = name.c_str();
	
	std::cout << "Please enter picture width: ";
	std::string width;
	std::cin >> width;
	const char* pictureWidthC = width.c_str();
	int pictureWidth = atoi(pictureWidthC);	
	
	std::cout << "Please enter picture hight: ";
	std::string hight;
	std::cin >> hight;
	const char* pictureHightC = hight.c_str();
	int pictureHight = atoi(pictureHightC);	
	
	//demonstraiting squares, blobs and triangels
	//1, 158, 13, 10, og 6 gir best resultat shapes bildet 
	//const char* pictureName = "shapes1030.bmp"; //bra
	//int pictureWidth = 301;
	//int pictureHight = 263;
	
	//const char* pictureName = "shapes.bmp"; //bra
	//int pictureWidth = 301;
	//int pictureHight = 263;
	
	//const char* pictureName = "lamper.bmp";
	//int pictureWidth = 469;
	//int pictureHight = 550;
	
	//lying picture exampels
	//int pictureWidth = 640;
	//int pictureHight = 480;

	//const char* pictureName = "hus2.bmp";
	//const char* pictureName = "food.bmp";
	//const char* pictureName = "food2.bmp";
	//const char* pictureName = "NTNU.bmp";
	//const char* pictureName = "person.bmp";
	//const char* pictureName = "shibuya.bmp";
	//const char* pictureName = "squares.bmp";
	//const char* pictureName = "sunset.bmp";
	//const char* pictureName = "train.bmp";
	
	//standing picture exampels
	//int pictureWidth = 480;
	//int pictureHight = 640;
	
	//const char* pictureName = "telefon.bmp"; //bra
	//const char* pictureName = "billiard.bmp";
	//const char* pictureName = "pocky.bmp";
	//const char* pictureName = "school.bmp";

	// initialize SDL
	if ( SDL_Init(SDL_INIT_TIMER|SDL_INIT_VIDEO) < 0 ) {
		fprintf(stderr, "Unable to init SDL: %s\n", SDL_GetError());
		exit(1);
	}

	SDL_GL_SetAttribute(SDL_GL_RED_SIZE,   8 ); // min 8bit red
	SDL_GL_SetAttribute(SDL_GL_GREEN_SIZE, 8 ); // min 8bit green
	SDL_GL_SetAttribute(SDL_GL_BLUE_SIZE,  8 ); // min 8bit blue
	SDL_GL_SetAttribute(SDL_GL_DEPTH_SIZE, 16); // 16bit depth buffer
	SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER,1); // require double buffering

	SDL_Surface *window = SDL_SetVideoMode(pictureWidth, pictureHight, 32, SDL_OPENGL);

	// create window of size 640 x 480 to draw on
	if (!window) {
		fprintf(stderr, "Unable to set 640x480 video: %s\n", SDL_GetError());
		exit(1);
	}

	//Plassere kameraet...
	glMatrixMode(GL_PROJECTION);				// Select The Projection Matrix
	glLoadIdentity();							// Reset The Projection Matrix
	//gluPerspective(45.0f,(GLfloat)pictureWidth/(GLfloat)pictureHight,0.1f,100.0f); //before
	//IMPORTEN LIMITATION!
	gluPerspective(45.0f,(GLfloat)pictureWidth/(GLfloat)pictureHight,0.1f,5000.0f);	// Calculate The Aspect Ratio Of The Window
	glEnable(GL_CULL_FACE);						// Slik at den tegner pÂ begge sider eller noe...
	glMatrixMode(GL_MODELVIEW);					// Select The Modelview Matrix
	glLoadIdentity();							// Reset The Modelview Matrix

	//Configure light-sorce
	float lightAmbient[]= {0.5f, 0.5f, 0.5f, 1.0f };			// grey Ambient Light Values
	glLightfv(GL_LIGHT1, GL_AMBIENT, lightAmbient);
	//float lightDiffuse[]= { 1.0f, 0.0f, 0.0f, 1.0f };			// red Diffuse Light Values
	float lightDiffuse[]= { 1.0f, 1.0f, 1.0f, 1.0f };			// bright Diffuse Light Values
	glLightfv(GL_LIGHT1, GL_DIFFUSE, lightDiffuse);
	glEnable(GL_LIGHT1);
	glEnable(GL_COLOR_MATERIAL);

	//Place light source in the scene
	float light_pos[] = { 0.0f, 0.0f, -2.0f, 1.0f };
	glLightfv(GL_LIGHT1, GL_POSITION, light_pos);
	glEnable(GL_LIGHT1);
	
	//Loade input image
	SDL_Surface *input_image = SDL_CreateRGBSurface(SDL_SWSURFACE, pictureWidth, pictureHight, 32, 0, 0, 0, 0);
	LoadBMP(pictureName, input_image);
	
	//make copy for image processing
	SDL_Surface *copy = SDL_CreateRGBSurface(SDL_SWSURFACE, pictureWidth, pictureHight, 32, 0, 0, 0, 0);
	//LoadBMP(pictureName, copy);
	
	//DRAW!
	DrawEdges(input_image, copy, pictureWidth, pictureHight);
	//DrawTriangle();
	
	// wait for mouse and keyboard events mens man tegner kontinuerlig
	int done = 0;
	while ( ! done ) {
	done = lytt();
	//Draw her? Nop trengs ikke
	SDL_GL_SwapBuffers( ); //Swap buffers
	}
	
	//Save image back to file.
    SDL_SaveBMP(input_image, "output.bmp");

	 return 0;
}
