/*
 *  linking.cpp
 *
 *  Created by Kari Haugsdal
 */

#include "linking.h"
#include <iostream>
#include <math.h>
#define PI 3.14159265

float ComputeDistanceBetweenTwoPoints(int lineStartX, int lineStartY, int lineStopX, int lineStopY){

	//distance between two points A(x1, y1) and B(x2, y2) is square root of sqrt((x2-x1)powerof2 + (y2-y1powerof2)) where powerof2 can be written pow(base,exponent)	
	return sqrt( abs( (pow(lineStopX-lineStartX, 2)) + (pow(lineStopY-lineStartY, 2)) ));
}

void LinkGaps(SDL_Surface *original, SDL_Surface *copy, int limit) {

	pixel * originalPixels = (pixel*) original->pixels;
	pixel * copyPixels = (pixel*) copy->pixels;
	
	//empty copy picture for saving purposess, that is make entire picture black
	for (int x = 0; x < original->w; x++) {
		for (int y = 0; y < original->h; y++) {
			copyPixels[x + y * (original->w)].r = 0;
			copyPixels[x + y * (original->w)].b = 0;
			copyPixels[x + y * (original->w)].g = 0;
		}
	}
	
	int gapValue = 6;
	
	//Looping through the pixels
	for (int x = 1; x < original->w-1; x++) {
		for (int y = 1; y < original->h-1; y++) {
			
			//find an edge start or end (not StartAndEnd as these already are complete objects!)
			if(originalPixels[x + y * (original->w)].r == 1 || originalPixels[x + y * (original->w)].r == 3){
				
				//ta vare pa pixel beeing processed verdier
				int pBPX, pBPY, pBPa, pBPb, pBPg;
				pBPX = x;
				pBPY = y;
				pBPa = copyPixels[x + y * (original->w)].r;
				pBPb = copyPixels[x + y * (original->w)].b;
				pBPg = copyPixels[x + y * (original->w)].g;
				
				//values for finding candidate
				bool candidateChosen = false;
				bool naboCandidateChosen = false;
				int candidateChosenX, candidateChosenY;
				int naboCandidateChosenX, naboCandidateChosenY;
				bool verySimilarACandidateChosen = false;
				int verySimilarACandidateChosenX, verySimilarACandidateChosenY;
				bool similarACandidateChosen = false;
				int similarACandidateChosenX, similarACandidateChosenY;
				bool distanceCandidateChosen = false;
				bool selfCandidateChosen = false;
				int selfCandidateChosenX, selfCandidateChosenY;
				int distanceCandidateChosenX, distanceCandidateChosenY;
				float biggestDistance = 0;
				
				//throw it over in copy, and mark it as .r=BP (beeig processed 5)
				copyPixels[x + y * (original->w)].r = 5;
				copyPixels[x + y * (original->w)].b = originalPixels[x + y * (original->w)].b;
				copyPixels[x + y * (original->w)].g = originalPixels[x + y * (original->w)].g;
				copyPixels[x + y * (original->w)].a = originalPixels[x + y * (original->w)].a;
			
				//Looping through the pixels one more time for finding the candidates
				for (int k = 1; k < original->w-1; k++) {
					for (int l = 1; l < original->h-1; l++) {
						
						//if pixl is an start or end and is within the range of beeing an candidate
						if((originalPixels[k + l * (original->w)].r == 1 || originalPixels[k + l * (original->w)].r == 3) && abs(x-k) < limit && abs(y-l) < limit){
						
							//throw them over to copy for more processing
							//vikitg a ikke sende over .r! da dette vil overskrive .r=5
							copyPixels[k + l * (original->w)].b = originalPixels[x + y * (original->w)].b;
							copyPixels[k + l * (original->w)].g = originalPixels[x + y * (original->w)].g;
							copyPixels[k + l * (original->w)].a = originalPixels[x + y * (original->w)].a;
						}
						
					}
				}//gong over the whole picture after candidates finished
				
				//Looping through the copy picture one more time for choosing the best candidate
				for (int k = 1; k < original->w-1; k++) {
					for (int l = 1; l < original->h-1; l++) {
						
						//case 1, choose pixel in 3x3 neighborhod over others
						//loop true the nieghbors of the processing pixel
						if(copyPixels[k + l * (original->w)].r == 5){
							
							for (int i = -1; i < 2; i++) {
								for (int j = -1; j < 2; j++) {
									if(copyPixels[(k + i) + (l + j) * (original->w)].b > 0 && copyPixels[(k + i) + (l + j) * (original->w)].r != 5 ){
										naboCandidateChosen = true;
										naboCandidateChosenX = k+i;
										naboCandidateChosenY = l+j;
									}
								}
							}
						}
						
						//if pixl is not 0 and .r != 5 it is an candidate
						if(copyPixels[k + l * (original->w)].b > 0 && copyPixels[k + l * (original->w)].r != 5){
						
							//case 2 same .a
							if(copyPixels[k + l * (original->w)].a == pBPa){
								verySimilarACandidateChosen = true;
								verySimilarACandidateChosenX = k;
								verySimilarACandidateChosenY = l;
							}
							
							//case 3 naboliggende .a
							int AT = 50;	//Will give the two neighbour angels, if considering special case 0 and 135
							int candidateA = copyPixels[k + l * (original->w)].a;
							if( abs(candidateA-pBPa) <= AT || (candidateA == 0 && pBPa == 135) || (candidateA == 135 && pBPa == 0) ){
								similarACandidateChosen = true;
								similarACandidateChosenX = k;
								similarACandidateChosenY = l;
							}
						
							//case 4, velg nermeste!
							float distance = ComputeDistanceBetweenTwoPoints(pBPX, pBPY, k, l);
							if( distance >= biggestDistance){
								biggestDistance = distance;
								distanceCandidateChosen = true;
								distanceCandidateChosenX = k;
								distanceCandidateChosenY = l;
							}
							
						}
						
					}
				}//gong over the whole picture for choosing the best candidate finished
				
				//Coose Bets Candidate!
				if(naboCandidateChosen){
					candidateChosen = true;
					candidateChosenX = naboCandidateChosenX;
					candidateChosenY = naboCandidateChosenY;
				}else if(verySimilarACandidateChosen){
					candidateChosen = true;
					candidateChosenX = verySimilarACandidateChosenX;
					candidateChosenY = verySimilarACandidateChosenY;
				}else if(similarACandidateChosen){
					candidateChosen = true;
					candidateChosenX = similarACandidateChosenX;
					candidateChosenY = similarACandidateChosenY;
				}else if(selfCandidateChosen){
					candidateChosen = true;
					candidateChosenX = selfCandidateChosenX;
					candidateChosenY = selfCandidateChosenY;
				}else if(distanceCandidateChosen) {
					candidateChosen = true;
					candidateChosenX = distanceCandidateChosenX;
					candidateChosenY = distanceCandidateChosenY;
				}
				
				//a candidate was chosen
				if(candidateChosen){
					//std::cout << " Candidate found " << std::endl;
					
					//find the values the new connected edge should get
					int bValue = originalPixels[x + y * (original->w)].b;
					int gValue = originalPixels[x + y * (original->w)].g;
					int otherEdgeEndTypeWillBe;
					if (originalPixels[x + y * (original->w)].r == 1){
						//end/start processed is a start, and then...
						otherEdgeEndTypeWillBe = 1;
					} else {
						//end/start processed is an end, and then...
						otherEdgeEndTypeWillBe = 3;
					}
					
					//sett the start/end beeing processed as G (gap) value
					originalPixels[x + y * (original->w)].r = gapValue;
					
					//change the whole edge of the chosen candidate to same .b and .g values as the edge processed, pluss change the endigs
					ChangeEdge(original, candidateChosenX, candidateChosenY, gapValue, otherEdgeEndTypeWillBe, bValue, gValue);
					
					//increse Gap value
					if(gapValue == 255){
						gapValue = 6;
					} else {
						gapValue++;
					}
					
				
				} else { //no candidate was found
					//nothing happens
					//std::cout << " No candidate found " << std::endl;
				}
				
				//afterwords empty copy image and move on to next start or end
				for (int s = 0; s < original->w; s++) {
					for (int t = 0; t < original->h; t++) {
						copyPixels[s + t * (original->w)].r = 0;
						copyPixels[s + t * (original->w)].b = 0;
						copyPixels[s + t * (original->w)].g = 0;
						copyPixels[s + t * (original->w)].a = 0;
					}
				}
			
			}//prosessing the edge start/end finished
		}
	}//going over the whole picture finished

}

void ChangeEdge(SDL_Surface *original, int startX, int startY, int startTypeWillBe, int endTypeWillBe, int newB, int newG){

	pixel * originalPixels = (pixel*) original->pixels;
	
	int oldB = originalPixels[startX + startY * (original->w)].b;
	int oldG = originalPixels[startX + startY * (original->w)].g;
	
	//print
	//int Type = originalPixels[startX + startY * (original->w)].r;
	//int B = originalPixels[startX + startY * (original->w)].b;
	//int G = originalPixels[startX + startY * (original->w)].g;
	//std::cout << "Old Start Pixel x: " << startX << " y: " << startY << " B Value: " << B << " G Value: " << G << " Type: " << Type  << std::endl;
	
	//change starting pixel
	originalPixels[startX + startY * (original->w)].r = startTypeWillBe;
	originalPixels[startX + startY * (original->w)].b = newB;
	originalPixels[startX + startY * (original->w)].g = newG;
	
	//special case when G connects to itself
	bool connectsToItself = false;
	if(oldB == newB && oldG == newG){
		//first pixel has to be a G (OK), second a SaE, last a G again
		connectsToItself = true;
	}
	
	//print
	//int StartType = originalPixels[startX + startY * (original->w)].r;
	//int StartB = originalPixels[startX + startY * (original->w)].b;
	//int StartG = originalPixels[startX + startY * (original->w)].g;
	//std::cout << "New StartPixel x: " << startX << " y: " << startY << " B Value: " << StartB << " G Value: " << StartG << " Type: " << StartType  << std::endl;
	
	int centerX = startX;
	int centerY = startY;
	int eTempCenterX, eTempCenterY, mTempCenterX, mTempCenterY, gTempCenterX, gTempCenterY, saeTempCenterX, saeTempCenterY;

	//Running as long as the method is linking a connected edge set
	bool notFinished = true;
	while (notFinished) {
		notFinished = false;
		
		//print
		//std::cout << "Print all the neighbours: " << std::endl;
		
		bool mNaboFunnet = false; 
		bool eNaboFunnet = false;
		bool gNaboFunnet = false;
		bool saeNaboFunnet = false;
		//Looping through the neighbours of the current pixel MINUS ITSELF
		for (int i = -1; i < 2; i++) {
			for (int j = -1; j < 2; j++) {
			
				//print
				
				//int NType = originalPixels[(centerX + i) + (centerY + j) * (original->w)].r;
				//int NPixelB = originalPixels[(centerX + i) + (centerY + j) * (original->w)].b;
				//int NPixelG = originalPixels[(centerX + i) + (centerY + j) * (original->w)].g;
				//int Nx = centerX + i;
				//int Ny = centerY + j;
				//std::cout << "Pixel x: " << Nx << " Pixel y: " << Ny << " B Value: " << NPixelB << " G Value: " << NPixelG << " Type: " << NType  << std::endl;
				
				int b = originalPixels[(centerX + i) + (centerY + j) * (original->w)].b;
				int g = originalPixels[(centerX + i) + (centerY + j) * (original->w)].g;
				int r = originalPixels[(centerX + i) + (centerY + j) * (original->w)].r;
				
				//funnet nabo, middel pixel
				if( b == oldB && g == oldG && r == 2 && !connectsToItself){
				
					mNaboFunnet = true;
					//put as new center pixel
					mTempCenterX = centerX + i;
					mTempCenterY = centerY + j;
					notFinished = true;
				}
				//funnet nabo, end eller start pixel
				if( b == oldB && g == oldG && (r == 3 || r == 1 || r == 4) && !connectsToItself){
				
					eNaboFunnet = true;
					//put as new center pixel
					eTempCenterX = centerX + i;
					eTempCenterY = centerY + j;
				}
				//funnet gap pixel!
				if( b == oldB && g == oldG && r >= 6 && !connectsToItself){
				
					gNaboFunnet = true;
					//put as new center pixel
					gTempCenterX = centerX + i;
					gTempCenterY = centerY + j;
				}
				
				if(connectsToItself && b == oldB && g == oldG) {
					//only find the first pixel, and set it to SaE, then exit while!
					saeNaboFunnet = true;
					saeTempCenterX = centerX + i;
					saeTempCenterY = centerY + j;
				}
										
			}
		}//looping through neighbors finished
		
		//now it is time to use naboene vi fant
		if(mNaboFunnet){
			//std::cout << "Middel nabo funnet:" << std::endl;
			centerX = mTempCenterX;
			centerY = mTempCenterY;
			
			//utprint
			//int nextPixelType = originalPixels[(centerX) + (centerY) * (original->w)].r;
			//int nextPixelB = originalPixels[(centerX) + (centerY) * (original->w)].b;
			//int nextPixelG = originalPixels[(centerX) + (centerY) * (original->w)].g;
			//std::cout << "Pixel x: " << centerX << " y: " << centerY << " B Value: " << nextPixelB << " G Value: " << nextPixelG << " Type: " << nextPixelType  << std::endl;
			
			//change pixel
			originalPixels[centerX + centerY * (original->w)].r = 2;
			originalPixels[centerX + centerY * (original->w)].b = newB;
			originalPixels[centerX + centerY * (original->w)].g = newG;
			
			//std::cout << "Change Middel nabo:" << std::endl;
			
			//utprint
			//int nextPixelTypeC = originalPixels[(centerX) + (centerY) * (original->w)].r;
			//int nextPixelBC = originalPixels[(centerX) + (centerY) * (original->w)].b;
			//int nextPixelGC = originalPixels[(centerX) + (centerY) * (original->w)].g;
			//std::cout << "Pixel x: " << centerX << " y: " << centerY << " B Value: " << nextPixelBC << " G Value: " << nextPixelGC << " Type: " << nextPixelTypeC  << std::endl;
			
		} else if(eNaboFunnet){
			//std::cout << "End/Start nabo funnet!" << std::endl;
			centerX = eTempCenterX;
			centerY = eTempCenterY;
			originalPixels[centerX + centerY * (original->w)].r = endTypeWillBe;
			originalPixels[centerX + centerY * (original->w)].b = newB;
			originalPixels[centerX + centerY * (original->w)].g = newG;
			
		} else if(gNaboFunnet){
			//std::cout << "G nabo funnet!" << std::endl;
			centerX = gTempCenterX;
			centerY = gTempCenterY;
			//behold old r valua as is
			int gapValue = originalPixels[centerX + centerY * (original->w)].r;
			originalPixels[centerX + centerY * (original->w)].b = newB;
			originalPixels[centerX + centerY * (original->w)].g = newG;
			
			//search whole picture after matching G and call ChangeEdge() on that one!
			
			for (int r = 1; r < original->w-1; r++) {
				for (int s = 1; s < original->h-1; s++) {
					
					int gType = originalPixels[r + s * (original->w)].r;
					int gB = originalPixels[r + s * (original->w)].b;
					int gG = originalPixels[r + s * (original->w)].g;
					
					if( gType == gapValue && gB == oldB && gG == oldG){
					
						//std::cout << "G nabo sin matchende G funnet!" << std::endl;
						ChangeEdge(original, r, s, gType, endTypeWillBe, newB, newG);
						
					}
				
				}
			}

		} else if(saeNaboFunnet){
			//std::cout << "SaE nabo funnet!" << std::endl;
			centerX = saeTempCenterX;
			centerY = saeTempCenterY;
			//set second pixel to SaE, then exit while
			originalPixels[centerX + centerY * (original->w)].r = 4;

		}

		
	}//while loop finished
	
	if(connectsToItself){
		//last step, search the whole picture after the edge end (start or end) and make it a G for gap
		//Looping through the pixels
		for (int x = 1; x < original->w-1; x++) {
			for (int y = 1; y < original->h-1; y++) {
			
				int r = originalPixels[x + y * (original->w)].r;
				int b = originalPixels[x + y * (original->w)].b;
				int g = originalPixels[x + y * (original->w)].g;
				
				if(( r == 1 || r == 3) && b == oldB && g == oldG){
					//found end/start pixel, change to gap
					originalPixels[x + y * (original->w)].r = startTypeWillBe; //which is gapValue
					
				}
				
			}
		}
		
	}//last step with special case connects to itself finished
	
	//std::cout << "Changing Edge Finished!" << std::endl;
	//std::cout << " " << std::endl;
	
}

