/*
 *  local_edge_linking.cpp
 *
 *  Created by Kari Haugsdal
 *
 */

#include "local_edge_linking.h"
#include <iostream>
//#include <cstdlib> //for random number

void Linking(SDL_Surface *original, SDL_Surface *copy) {


	pixel * originalPixels = (pixel*) original->pixels;
	pixel * copyPixels = (pixel*) copy->pixels;
	
	//empty copy picture for saving purposess, that is make entire picture black
	for (int x = 0; x < original->w; x++) {
		for (int y = 0; y < original->h; y++) {
			copyPixels[x + y * (original->w)].r = 0;
			copyPixels[x + y * (original->w)].b = 0;
			copyPixels[x + y * (original->w)].g = 0;
		}
	}
	
	int edgeValueB = 1;
	int edgeValueG = 255;
	int start = 1;
	int middle = 2;
	int end = 3;
	int startAndEnd = 4;
	
	//Looping through the pixels
	for (int x = 1; x < original->w-1; x++) {
		for (int y = 1; y < original->h-1; y++) {
		
			//If we encounter an edge we start tracing it
			if(originalPixels[x + y * (original->w)].g != 0){
			
				int centrePixelX = x;
				int centrePixelY = y;
				
				copyPixels[centrePixelX + centrePixelY * (original->w)].r = start;
				
				//Running as long as the method is linking a connected edge set
				int foundStrongCandidate = 1;
				int foundWeakCandidate = 1;
				while (foundStrongCandidate > 0 || foundWeakCandidate > 0 ) {
					foundStrongCandidate = 0;
					foundWeakCandidate = 0;
					bool startEqualsEnd = false;
					
					int	biggestMSoFare = 0;
					int biggestWeakMSoFare = 0;
					int newCentrePixelX;
					int newCentrePixelY;
					int newWeakCentrePixelX;
					int newWeakCentrePixelY;
					
					//Add centre pixel to copy picture
					if (copyPixels[centrePixelX + centrePixelY * (original->w)].r != start){ //problem! har .r noe fra f;r av?
						copyPixels[centrePixelX + centrePixelY * (original->w)].r = middle;
					}
					copyPixels[centrePixelX + centrePixelY * (original->w)].b = edgeValueB;
					copyPixels[centrePixelX + centrePixelY * (original->w)].g = edgeValueG;
					
					//Print All the Edges!
					int PixelValuehb = copyPixels[centrePixelX + centrePixelY * (original->w)].b;
					int PixelValuehg = copyPixels[centrePixelX + centrePixelY * (original->w)].g;
					int PixelTypeh = copyPixels[centrePixelX + centrePixelY * (original->w)].r;
					//std::cout << "Pixel x: " << centrePixelX  << " y: " << centrePixelY << " B Value : " << PixelValuehb << " G Value : " << PixelValuehg << " Type : " << PixelTypeh << std::endl;
					
					//Get M and a
					int magnitudeCentrePixel = originalPixels[centrePixelX + centrePixelY * (original->w)].g;	// verdi mellom 0 (svart, ingen pixel) og 255 
					int angleCentrePixel = originalPixels[centrePixelX + centrePixelY * (original->w)].a;		//enten  0, 45, 90 eller 135
					
					//Delete Centre Pixel from original.
					originalPixels[centrePixelX + centrePixelY * (original->w)].r = 0;
					originalPixels[centrePixelX + centrePixelY * (original->w)].b = 0;
					originalPixels[centrePixelX + centrePixelY * (original->w)].g = 0;
					
					//Looping through the neighbours of the current pixel
					for (int i = -1; i < 2; i++) {
						for (int j = -1; j < 2; j++) {
							
							//get neighbor M and a
							int magnitude = originalPixels[(centrePixelX + i) + (centrePixelY + j)* (original->w)].g;
							int angle = originalPixels[(centrePixelX + i) + (centrePixelY + j)* (original->w)].a;
							
							//Magnitude and Angle Threshold
							int MT = 200;	//big threshold for now
							int AT = 50;	//Will give the two neighbour angels, if considering special case 0 and 135
							
							//velg sterk kandidat
							if (abs(magnitude-magnitudeCentrePixel) <= MT && (abs(angle-angleCentrePixel) <= AT || (angle == 0 && angleCentrePixel == 135) || (angle == 135 && angleCentrePixel == 0)) && magnitude > biggestMSoFare){

								foundStrongCandidate = 1; //Neighbor found demand satesfied!
								biggestMSoFare = magnitude;
								newCentrePixelX = centrePixelX + i; 
								newCentrePixelY = centrePixelY + j;
								
							//if ther eis a neighbour, not strong enoufh, but still a neigbour, mark as weak candidate	
							} else if (magnitude > 0 && magnitude > biggestWeakMSoFare) { 
							
								foundWeakCandidate = 1;
								biggestWeakMSoFare = magnitude;
								newWeakCentrePixelX = centrePixelX + i; 
								newWeakCentrePixelY = centrePixelY + j;
							}
						}
					}//looping through neighbors finished
					
					if (foundStrongCandidate == 1){										//found new strong pixel to edge set
						centrePixelX = newCentrePixelX;									
						centrePixelY = newCentrePixelY;
					}
					else if(foundStrongCandidate == 0 && foundWeakCandidate == 1){		//found new weak pixel to edge set and no strong
						centrePixelX = newWeakCentrePixelX;								
						centrePixelY = newWeakCentrePixelY;
					}
					else if(foundStrongCandidate == 0 && foundWeakCandidate == 0){		//didnt find new pixel to edge set, found end
					
						//search after its own start around the copy neighbourhod, if found, then start is end and we have an object!
						for (int i = -1; i < 2; i++) {
							for (int j = -1; j < 2; j++) {
								if(copyPixels[(centrePixelX + i) + (centrePixelY + j)* (original->w)].r == start && copyPixels[(centrePixelX + i) + (centrePixelY + j)* (original->w)].b == edgeValueB  && copyPixels[(centrePixelX + i) + (centrePixelY + j)* (original->w)].g == edgeValueG){
									copyPixels[(centrePixelX + i) + (centrePixelY + j)* (original->w)].r = startAndEnd;
									startEqualsEnd = true;
									//Print the end of Edge
									int PixelValuerb = copyPixels[(centrePixelX + i) + (centrePixelY + j) * (original->w)].b;
									int PixelValuerg = copyPixels[(centrePixelX + i) + (centrePixelY + j) * (original->w)].g;
									int PixelTyper = copyPixels[(centrePixelX + i) + (centrePixelY + j) * (original->w)].r;
									//std::cout << "Pixel x: " << centrePixelX + i  << " y: " << centrePixelY + j << " B Value : " << PixelValuerb << " G Value : " << PixelValuerg << " Type : " << PixelTyper << std::endl;
									//std::cout << " " << std::endl;
								}
							}
						}
						
						//normal end
						if(startEqualsEnd == false){
							copyPixels[centrePixelX + centrePixelY * (original->w)].r = end;
							
							//Print the end of Edge
							int PixelValuefb = copyPixels[centrePixelX + centrePixelY * (original->w)].b;
							int PixelValuefg = copyPixels[centrePixelX + centrePixelY * (original->w)].g;
							int PixelTypef = copyPixels[centrePixelX + centrePixelY * (original->w)].r;
							//std::cout << "Pixel x: " << centrePixelX  << " y: " << centrePixelY << " B Value : " << PixelValuefb << " G Value : " << PixelValuefg << " Type : " << PixelTypef << std::endl;
							//std::cout << " " << std::endl;
						}
						
						//increase the edge set value set by .b and .g
						if(edgeValueB == 255){
							edgeValueB = 1;
							edgeValueG--;
						} else {
							edgeValueB++;
						}
					}

				}//while loop, linking a connected edge set finished
			}
			
		}
	}//going over the whole picture finished


	for (int x = 0; x < original->w; x++) {
		for (int y = 0; y < original->h; y++) {
			originalPixels[x + y * (original->w)].r = copyPixels[x + y * (original->w)].r;
			originalPixels[x + y * (original->w)].b = copyPixels[x + y * (original->w)].b;
			originalPixels[x + y * (original->w)].g = copyPixels[x + y * (original->w)].g;
		}
	}

}

void LinkEndings(SDL_Surface *original, SDL_Surface *copy) {


	pixel * originalPixels = (pixel*) original->pixels;
	
	//edge pixel types
	int start = 1;
	int end = 3;
	bool foundS;
	bool foundE; 
	int SX, SY, EX, EY;
	
	//Looping through the pixels
	for (int x = 1; x < original->w-1; x++) {
		for (int y = 1; y < original->h-1; y++) {
		
			//If we encounter an start pixel we start linking it with neighbours in the 3x3 neighbourhood.
			//This is to fix the probem that comes from choosing a random start pixel that might be in the midle of an edge.
			if(originalPixels[x + y * (original->w)].r != 0 && originalPixels[x + y * (original->w)].r == start){
			
					int angleCentrePixel = originalPixels[x + y * (original->w)].a;	//0, 45, 90 or 135
					bool foundBestSCandidate = false;
					bool foundNextBestSCandidate = false; 
					bool foundBestECandidate = false;
					bool foundNextBestECandidate = false; 
					
					//Looping through the neighbours of the current pixel MINUS THEM SELFH!
					for (int i = -1; i < 2; i++) {
						for (int j = -1; j < 2; j++) {
							
							//get edge pixel type
							int EdgePixelType = originalPixels[(x + i) + (y + j)* (original->w)].r;
							int angle = originalPixels[(x + i) + (y + j)* (original->w)].a;
							int AT = 50;	//Angel Threshold that will give the two neighbour angels, if considering special case 0 and 135
							
							if (EdgePixelType == start && !(j == 0 && i == 0)){
							
								//find best S candidate in neighbourhod using .a
								foundS = true;
								
								if (angle == angleCentrePixel){			//same angel candidate	
									foundBestSCandidate = true;
									SX = x + i; 
									SY = y + j;
								}
								else if ( (abs(angle-angleCentrePixel) <= AT || (angle == 0 && angleCentrePixel == 135) || (angle == 135 && angleCentrePixel == 0)) && !foundBestSCandidate ){	//neighbour angel candidates
									foundNextBestSCandidate = true;
									SX = x + i; 
									SY = y + j;
								}
								else if (!foundBestSCandidate && !foundNextBestSCandidate) { // the rest
									SX = x + i; 
									SY = y + j;
								}

							} else if (EdgePixelType == end && !(j == 0 && i == 0) ) {
							
								//find best E candidate in neighbourhod using .a
								foundE = true;
								
								if (angle == angleCentrePixel){			//same angel candidate	
									foundBestECandidate = true;
									EX = x + i; 
									EY = y + j;
								}
								else if ( (abs(angle-angleCentrePixel) <= AT || (angle == 0 && angleCentrePixel == 135) || (angle == 135 && angleCentrePixel == 0)) && !foundBestECandidate ){	//neighbour angel candidates
									foundNextBestECandidate = true;
									EX = x + i; 
									EY = y + j;
								}
								else if (!foundBestECandidate && !foundNextBestECandidate) { // the rest
									EX = x + i; 
									EY = y + j;
								}
								
							}
						}
					}//looping through neighbors finished
					
					if (foundS){
						
						//print cndidate chosen
						if(foundBestSCandidate){
							//std::cout << " Best S Candidate " << std::endl;
						}else if(foundNextBestSCandidate){
							//std::cout << " Next Best S Candidate " << std::endl;
						}
						else {
							//std::cout << " Worst S Candidate " << std::endl;
						}
						
						//make both the edges same edge value, and change the ending
						ChangeTheValueOfAnEdge(original, copy, SX, SY, start, originalPixels[x + y * (original->w)].b, originalPixels[x + y * (original->w)].g);
						foundS = false;
						foundE = false;
					}	
					else if(foundE){
						
						//print cndidate chosen
						if(foundBestECandidate){
							//std::cout << " Best E Candidate " << std::endl;
						}else if(foundNextBestECandidate){
							//std::cout << " Next Best E Candidate " << std::endl;
						}
						else {
							//std::cout << " Worst E Candidate " << std::endl;
						}
					
						//make both the edges same edge value, and change the ending
						ChangeTheValueOfAnEdge(original, copy, EX, EY, start, originalPixels[x + y * (original->w)].b, originalPixels[x + y * (original->w)].g);
						foundS = false;
						foundE = false;
					}

			}
			
		}
	}//going over the whole picture finished

}

void ChangeTheValueOfAnEdge(SDL_Surface *original, SDL_Surface *copy, int StartPixelX, int StartPixelY, int EndPixelType, int TheNewBEdgeValue, int TheNewGEdgeValue){

	pixel * originalPixels = (pixel*) original->pixels;
	
	//get Old Pixel Value
	int oldBPixelValue = originalPixels[StartPixelX + StartPixelY * (original->w)].b;
	int oldGPixelValue = originalPixels[StartPixelX + StartPixelY * (original->w)].g;
	
	int oldPixelType = originalPixels[StartPixelX + StartPixelY * (original->w)].r;	
	std::cout << "Start Pixel x: " << StartPixelX  << " y: " << StartPixelY << " B Value : " << oldBPixelValue << " G Value : " << oldGPixelValue << " Type : " << oldPixelType  << std::endl;
	
	//change starting pixel type to middle
	originalPixels[StartPixelX + StartPixelY * (original->w)].r = 2;
	
	int centrePixelX = StartPixelX;
	int centrePixelY = StartPixelY;

	//Running as long as the method is linking a connected edge set
	int foundCandidate = 1;
	while (foundCandidate > 0) {
		foundCandidate = 0;
		int newCentrePixelX;
		int newCentrePixelY;

		//CHANGE EDGE VALUE of center pixel
		originalPixels[centrePixelX + centrePixelY * (original->w)].b = TheNewBEdgeValue;
		originalPixels[centrePixelX + centrePixelY * (original->w)].g = TheNewGEdgeValue;
		
		int changedBPixelValue = originalPixels[centrePixelX + centrePixelY * (original->w)].b;
		int changedGPixelValue = originalPixels[centrePixelX + centrePixelY * (original->w)].g;
		int changedPixelType = originalPixels[centrePixelX + centrePixelY * (original->w)].r;
		std::cout << "Changed Pixel x: " << centrePixelX  << " y: " << centrePixelY << " B Value : " << changedBPixelValue << " G Value : " << changedGPixelValue<< " Type : " << changedPixelType << std::endl;
					
		//Looping through the neighbours of the current pixel MINUS ITSELF
		for (int i = -1; i < 2; i++) {
			for (int j = -1; j < 2; j++) {
							
				//find candidate
				if (originalPixels[(centrePixelX + i) + (centrePixelY + j) * (original->w)].b == oldBPixelValue && originalPixels[(centrePixelX + i) + (centrePixelY + j) * (original->w)].g == oldGPixelValue && !(j == 0 && i == 0)){
					foundCandidate = 1;
					newCentrePixelX = centrePixelX + i; 
					newCentrePixelY = centrePixelY + j;		
				} 						
			}
		}//looping through neighbors finished
		
		//Candidate found
		if (foundCandidate == 1){
			centrePixelX = newCentrePixelX;
			centrePixelY = newCentrePixelY;
		}
		//No candidate found, we are at end pixel
		else if(foundCandidate == 0){
		
			int EndBPixelValue = originalPixels[centrePixelX + centrePixelY * (original->w)].b;
			int EndGPixelValue = originalPixels[centrePixelX + centrePixelY * (original->w)].g;
			originalPixels[centrePixelX + centrePixelY * (original->w)].r = EndPixelType;
			std::cout << "End Pixel x: " << centrePixelX  << " y: " << centrePixelY << " B Value : " << EndBPixelValue << " G Value : " << EndGPixelValue << " Type : " << EndPixelType << std::endl;
			
			/**
			//print ut alle naboer av siste pixel
			for (int i = -1; i < 2; i++) {
				for (int j = -1; j < 2; j++) {
				
					if(!(j == 0 && i == 0)){
				
						int xV = (centrePixelX + i);
						int yV = (centrePixelY + j);
						int b = originalPixels[(centrePixelX + i) + (centrePixelY + j) * (original->w)].b;
						int g = originalPixels[(centrePixelX + i) + (centrePixelY + j) * (original->w)].g;
						int r = originalPixels[(centrePixelX + i) + (centrePixelY + j) * (original->w)].r;
						//oldBPixelValue;
						//oldGPixelValue;
						
						std::cout << "Naboer av End Pixel x: " << xV  << " y: " << yV << " B Value : " << b << " G Value : " << g << " Type : " << r << std::endl;
					}
				}
			}
			**/
			
			std::cout << " " << std::endl;
		}
		
	}//while loop, linking a connected edge set finished

}

