/*
 *  nonmaxima_suppression.cpp
 *
 *  Created by Kari Haugsdal
 *
 */

#include <iostream>
#include "nonmaxima_suppression.h"

/* nonmaximaSuppression to thin the edges */
void NonmaximaSuppression(SDL_Surface *surface, SDL_Surface *copy) {

  int degreeAngle = 0; //gjort om til int
  
  // aquire pointer to pixel data
  pixel * pixels = (pixel*) surface->pixels;
  pixel * copyPixels = (pixel*) copy->pixels;

  int x;
  int y;
  for (x = 0; x < surface->w; x++) {
    for (y = 0; y < surface->h; y++) {
	
		degreeAngle = pixels[x + y*(surface->w)].a;
			
		//Find the direction dk (where d1, d2, d3 and d4 detonates the directions, 
		//horizontal, -45 degrees, vertical and +45 degrees) that is closest to the point (x, y) 
		//If the value of the point (x,y) in G is less than minimum one of its two neighbors along dk, 
		//then let the point Gn = 0 (suppression). If not, let the point Gn = the point in G.
		
		//Legge til enda større tall!
		if ( degreeAngle == 135) {
			//-45 degrees
			if(pixels[x + y*(surface->w)].b < pixels[(x-1) + (y-1)*(surface->w)].b || pixels[x + y*(surface->w)].b < pixels[(x+1) + (y+1)*(surface->w)].b) {
				copyPixels[x + y*(surface->w)].r = 0;
				copyPixels[x + y*(surface->w)].g = 0;
				copyPixels[x + y*(surface->w)].b = 0;
			}
			else {
				copyPixels[x + y*(surface->w)].r = pixels[x + y*(surface->w)].r;
				copyPixels[x + y*(surface->w)].g = pixels[x + y*(surface->w)].g;
				copyPixels[x + y*(surface->w)].b = pixels[x + y*(surface->w)].b;
			}
		}
		else if ( degreeAngle == 90) {
			//vertical
			if(pixels[x + y*(surface->w)].b < pixels[x + (y-1)*(surface->w)].b || pixels[x + y*(surface->w)].b < pixels[x + (y+1)*(surface->w)].b) {

				copyPixels[x + y*(surface->w)].r = 0;
				copyPixels[x + y*(surface->w)].g = 0;
				copyPixels[x + y*(surface->w)].b = 0;
			}
			else {
				copyPixels[x + y*(surface->w)].r = pixels[x + y*(surface->w)].r;
				copyPixels[x + y*(surface->w)].g = pixels[x + y*(surface->w)].g;
				copyPixels[x + y*(surface->w)].b = pixels[x + y*(surface->w)].b;
			}
		}
		else if ( degreeAngle == 45) {
			//+45 degree
			if(pixels[x + y*(surface->w)].b < pixels[(x-1) + (y+1)*(surface->w)].b || pixels[x + y*(surface->w)].b < pixels[(x+1) + (y-1)*(surface->w)].b) {
				copyPixels[x + y*(surface->w)].r = 0;
				copyPixels[x + y*(surface->w)].g = 0;
				copyPixels[x + y*(surface->w)].b = 0;
			}
			else {
				copyPixels[x + y*(surface->w)].r = pixels[x + y*(surface->w)].r;
				copyPixels[x + y*(surface->w)].g = pixels[x + y*(surface->w)].g;
				copyPixels[x + y*(surface->w)].b = pixels[x + y*(surface->w)].b;
			}
		}
		else{
			//horizontal
			if(pixels[x + y*(surface->w)].b < pixels[(x-1) + y*(surface->w)].b || pixels[x + y*(surface->w)].b < pixels[(x+1) + y*(surface->w)].b) {
				copyPixels[x + y*(surface->w)].r = 0;
				copyPixels[x + y*(surface->w)].g = 0;
				copyPixels[x + y*(surface->w)].b = 0;
			}
			else {
				copyPixels[x + y*(surface->w)].r = pixels[x + y*(surface->w)].r;
				copyPixels[x + y*(surface->w)].g = pixels[x + y*(surface->w)].g;
				copyPixels[x + y*(surface->w)].b = pixels[x + y*(surface->w)].b;
			}
		}
		
	
	}
  }
  
  int xx;
  int yy;
  for (xx = 0; xx < surface->w; xx++) {
    for (yy = 0; yy < surface->h; yy++) {

		pixels[xx + yy*(surface->w)].r = copyPixels[xx + yy*(surface->w)].r;
		pixels[xx + yy*(surface->w)].g = copyPixels[xx + yy*(surface->w)].g;
		pixels[xx + yy*(surface->w)].b = copyPixels[xx + yy*(surface->w)].b;
    }
  }
  
}