/*
 *  thinning.cpp
 *  project
 *
 *  Created by Kari Haugsdal
 *
 */
#include <iostream>
#include "thinning.h"

void Thinning(SDL_Surface *original, SDL_Surface *copy) {


	
	pixel * originalPixels = (pixel*) original->pixels;
	pixel * copyPixels = (pixel*) copy->pixels;
	

	//The masks
	int mask[8][3][3] = { { { 1, 1, 1 }, { 2, 0, 2 }, { 0, 0, 0 } },
			              { { 2, 1, 1 }, { 0, 0, 1 }, { 0, 0, 2 } },
			              { { 0, 2, 1 }, { 0, 0, 1 }, { 0, 2, 1 } },
			              { { 0, 0, 2 }, { 0, 0, 1 }, { 2, 1, 1 } },
			              { { 0, 0, 0 }, { 2, 0, 2 }, { 1, 1, 1 } },
			              { { 2, 0, 0 }, { 1, 0, 0 }, { 1, 1, 2 } },
			              { { 1, 2, 0 }, { 1, 0, 0 }, { 1, 2, 0 } },
			              { { 1, 1, 2 }, { 1, 0, 0 }, { 2, 0, 0 } }};

	//Running as long as some pixels are changing!
	int changes = 1;
	while (changes > 0) {
		changes = 0;

		//Looping through the filters
		for (int n = 0; n < 8; n++) {
			//Looping through the pixels
			for (int x = 1; x < original->w - 1; x++) {
				for (int y = 1; y < original->h - 1; y++) {

					//Looping through the neighbours of the current pixel
					bool valid = true;
					for (int i = -1; i < 2; i++) {
						for (int j = -1; j < 2; j++) {
						
							//The picture is grayscale so we are looking at all color channels
							int red = originalPixels[(x + i) + (y + j)* (original->w)].r;
							int green = originalPixels[(x + i) + (y + j)* (original->w)].g;
							int blue = originalPixels[(x + i) + (y + j)* (original->w)].b;
							int maskVal = mask[n][j + 1][i + 1];

							//Is this neighbour fitting the mask? //stemer ikke helt?
							if (!(maskVal == 2 || (maskVal == 0 && (red > 0 || blue > 0 || green > 0)) || (maskVal == 1 && red == 0 && green == 0 && blue == 0))) {
								valid = false;
								goto afterLoop;
							}
						}
						//Here be dragons! Arr!
					}
					afterLoop:

					// Did the mask fit?
					if (valid) {
						changes++;

						//delete pixel in the midle of the mask, chnge to black, 0
						copyPixels[x + y * (original->w)].r = 0;
						copyPixels[x + y * (original->w)].b = 0;
						copyPixels[x + y * (original->w)].g = 0;
					}
				}
			}

			
			//Ugly! The pixels we just changed should now be the original
			for (int a = 0; a < original->w; a++) {
				for (int c = 0; c < original->h; c++) {
					originalPixels[a + c * (original->w)].r = copyPixels[a + c * (original->w)].r;
					originalPixels[a + c * (original->w)].b = copyPixels[a + c * (original->w)].b;
					originalPixels[a + c * (original->w)].g = copyPixels[a + c * (original->w)].g;
				}
			}
			
		}
		//std::cout << "Changes: " << changes << std::endl;
	}
}